/*----------------------------------------------------------------------------
 *
 * The information contained in this file is confidential and 
 * proprietary to Conexant Systems Inc.
 * No part of this file may be reproduced or distributed, in any form
 * or by any means for any purpose, without the express written
 * permission of Conexant Systems Inc.
 *
 * Copyright (C) 1996-2001 Conexant Systems Inc. 
 * All rights reserved.
 *
 *----------------------------------------------------------------------------
 *
 * File: DbgFuncs.h
 *
 * File : DbgFuncs.h
 * 
 * Description : Contains macros for debug printings (to WinICE).
 *
 *----------------------------------------------------------------------------
 */
 
#ifndef __DBGFUNCS_H__
#define __DBGFUNCS_H__



#ifdef VERBOSE

#ifdef DEBUG

#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )
#define DPRINTF(ARGS)	dprintf ARGS
#endif

#if ( OS_ONE_OF(OS_WIN_NT4 | OS_WIN_WDM) )
#define DPRINTF(ARGS)	{					\
						  DbgPrint ARGS;	\
						  DbgPrint ("\n");	\
						}
#endif

#else /* No DEBUG: */

#define DPRINTF(ARGS)	NPRINTF(ARGS)

#endif

#else  /* No VERBOSE: */

#define DPRINTF(ARGS)

#endif 


#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )

#define NPRINTF(ARGS)	nprintf ARGS

#elif ( OS_ONE_OF(OS_WIN_NT4 | OS_WIN_WDM) )

#define NPRINTF(ARGS)	{					\
						  DbgPrint ARGS;	\
						  DbgPrint ("\n");	\
						}

#else

/* here we will have to define the printf's for non VXD environments */
#define NPRINTF(ARGS)

#endif



#endif /* __DBGFUNCS_H__ */
