#ifndef __DIAGDEFS_H__
#define __DIAGDEFS_H__

#include "softadsl\nilehwiotypes.h"
#include "intfctrl_ex.h"
#include "comctrl_ex.h"

#define DIAG_MAX_CLIENT 3
#define DIAG_MAX_CLIENT_NAME 10

typedef enum
{
	DIAG_PAN_GRAPH,
	DIAG_SCATTER_GRAPH,
	DIAG_BAR_GRAPH,
	DIAG_CURVE_GRAPH,
	DIAG_STRING,
	DIAG_SCALAR,
}DIAG_VIEW;

typedef struct
{
	char	ClientNames[DIAG_MAX_CLIENT][DIAG_MAX_CLIENT_NAME];
	int		ClientNum;
}DIAG_CLIENT_INSTANCES_T;


typedef struct
{
	DIAG_PARAMS_T DiagParams;
	char          ClientName[DIAG_MAX_CLIENT_NAME];
}DIAG_CLIENT_INFO_T;


typedef BOOL (*PFUNC_DIAG_MONITOR) ( char			hInstance[DIAG_MAX_CLIENT_NAME],
									 DIAG_PARAMS_T	*pDiagParams );

typedef VOID (*PFUNC_DIAG_CLOSE) (VOID);

typedef int (*PFUNC_GET_DIAG_MONITOR) ( char	  				 *pInstanceName,
										PFUNC_DIAG_MONITOR		 *pFuncDiagMonitor,
									    HANDLE					 *phInstance,
									    PFUNC_DIAG_CLOSE   	     *pCloseFunc);


typedef BOOL (*PFUNC_GET_INSTANCE_LIST)( DIAG_CLIENT_INSTANCES_T *pDiagClientInfo);




#endif