/*----------------------------------------------------------------------------
 *
 * The information contained in this file is confidential and 
 * proprietary to Conexant Systems Inc.
 * No part of this file may be reproduced or distributed, in any form
 * or by any means for any purpose, without the express written
 * permission of Conexant Systems Inc.
 *
 * Copyright (C) 1996-2001 Conexant Systems Inc. 
 * All rights reserved.
 *
 *----------------------------------------------------------------------------
 *
 * File: CommonDefs.h
 *
 * Define useful values and independent macros.
 *
 *----------------------------------------------------------------------------
 */

#ifndef __STD_DEFINES_H__
#define __STD_DEFINES_H__


#define SCHAR_MIN   (-128)             /* minimum signed char value    */
#define SCHAR_MAX     127              /* maximum signed char value    */
#define UCHAR_MAX     0xff             /* maximum unsigned char value  */
#define SHRT_MIN    (-32768)           /* minimum (signed) short value */
#define SHRT_MAX      32767            /* maximum (signed) short value */
#define USHRT_MAX     0xffff           /* maximum unsigned short value */
#define INT_MIN     (-2147483647 - 1)  /* minimum (signed) int value   */

#ifndef INT_MAX
#define INT_MAX       2147483647       /* maximum (signed) int value   */
#endif

#ifndef UINT_MAX
#define UINT_MAX      0xffffffff       /* maximum unsigned int value   */
#endif

#define LONG_MIN    (-2147483647L - 1) /* minimum (signed) long value  */

#ifndef LONG_MAX
#define LONG_MAX      2147483647L      /* maximum (signed) long value  */
#endif

#ifndef ULONG_MAX
#define ULONG_MAX     0xffffffffUL     /* maximum unsigned long value  */
#endif

#define DWORD_LEN            ( (int) 32 )


#ifndef MAX
#define MAX(a,b)             ( ((a) > (b)) ? (a) : (b) )
#endif

#ifndef MIN
#define MIN(a,b)             ( ((a) < (b)) ? (a) : (b) )
#endif

#ifndef BIT_MASK
#define BIT_MASK(bits_count) ( (1 << (bits_count)) - 1 )
#endif

#ifndef ARRAY_SIZE
#define ARRAY_SIZE(a)   (sizeof(a)/sizeof(*(a)))
#endif


#define M_ZERO      ( (float) 0.0 )
#define M_ONE       ( (float) 1.0 )
#ifndef M_PI
#define M_PI        ( 3.1415926535897932384626433832795 )
#endif
#define M_PIF       ( (float) M_PI )
#ifndef M2_PI
#define M2_PI       ( 6.28318530717958647692528676655901 )
#endif
#ifndef M_SQRT2
#define M_SQRT2     ( 0.707106781186547524400844362104849 )
#endif

/* Stringification:
 * StringIt(x) will make "x"
 * StringItVal(x) will parse x and put that as a string (at least under gcc):
 * > #define XXX 88
 * > StringIt(XXX) is "XXX"
 * > StringItVal(XXX) is "88" ! */
#define StringIt(x)    #x
#define StringItVal(x) StringIt(x)


#endif /* __STD_DEFINES_H__ */
