/*************************************************************************

  File Name: ConfigCodes.h

  File Description:

  *************************************************************************/

#ifndef __CONFIGCODES_H__
#define __CONFIGCODES_H__
#include "comtypes.h"
/* //////////////////////////////////////////////////////////////// */
/* Data in AtCmd.c (AtPlusMS) relies on the enum order
 If make any changes in this enum - modify that data as well */

typedef enum {
	MODULATION_TYPE_BELL103,
	MODULATION_TYPE_BELL212,		
	MODULATION_TYPE_V21,
	MODULATION_TYPE_V22,		
	MODULATION_TYPE_V22BIS,		
	MODULATION_TYPE_V23,		
	MODULATION_TYPE_V32,		
	MODULATION_TYPE_V32BIS,		
	MODULATION_TYPE_V34,		
	MODULATION_TYPE_K56,		
	MODULATION_TYPE_V90,		
	MODULATION_TYPE_VFC,		

	MODULATION_TYPE_K56A,
    MODULATION_TYPE_V34_CLEAR,
    MODULATION_TYPE_V33,
    MODULATION_TYPE_V32BIS_CLEAR,
	MODULATION_TYPE_V29,		
	MODULATION_TYPE_V27,
    MODULATION_TYPE_V21C2, 
    MODULATION_TYPE_V17,
}MODULATION_TYPE;

// See DevMgr_Control function + DEVMGR_SET_DAA_STATE control code
typedef enum {
	DEVMGR_GPIO_RELAY_MASK,
	DEVMGR_GPIO_DEFAULT_STATE,
	DEVMGR_OFFHOOK_PHONETOLINE,
	DEVMGR_OFFHOOK_PHONEOFFLINE,
	DEVMGR_ONHOOK_PHONETOLINE_CALLID,
	DEVMGR_ONHOOK_PHONETOLINE_NOCALLID,
	DEVMGR_ONHOOK_PHONEOFFLINE_CALLID,
	DEVMGR_ONHOOK_PHONEOFFLINE_NOCALLID,
	DEVMGR_OFFHOOK_PULSE_MAKE,
	DEVMGR_OFFHOOK_PULSE_BREAK,
	DEVMGR_OFFHOOK_PULSESETUP,
	DEVMGR_OFFHOOK_PULSECLEAR,
	DEVMGR_LAST_RELAY_ENTRY
} DEVMGR_DAA_RELAY_CODE;

typedef enum {
	ANSWER_MODE,
	CALLER_MODE
} CALL_MODE;
typedef enum 
{
    CFGMGR_MS_STR,                               /* +ms parameters */
    CFGMGR_MS_PARAMS,                               /* +ms parameters */
    CFGMGR_EC_PARAMS,                               /* PEC_USER_CONFIG EC parameters */
    CFGMGR_COMPRESSION_PARAMS,                      /* PCOMPRESSION_USER_CONFIG compression parameters */
    CFGMGR_COMPRESSION_ENABLE,                      /* UINT8 */
    CFGMGR_RETRAIN_ENABLED,                         /* */
    CFGMGR_K56_USE_ULAW,
    CFGMGR_DCD_ON,
    CFGMGR_CADENCE_PARAMS,                          /* CADENCE_CFG * - params of the cadence */

    /* AT-parser to LMON */
    CFGMGR_FORCE_RENEG_UP,                          /* UINT8            */
    CFGMGR_FORCE_RENEG_DOWN,                        /* UINT8            */
    CFGMGR_IN_V34FAX,                               /* UINT8            */

    /* S-Registers  - UINT8 */
	CFGMGR_SREG,									/* S0 */
	CFGMGR_NRINGS_TO_ANSWER     = CFGMGR_SREG+0,	/* Number of rings before modem answers the call */
	CFGMGR_RING_COUNTER         = CFGMGR_SREG+1,    /* Number of rings detected */
	CFGMGR_ESCAPE_CHAR          = CFGMGR_SREG+2,    /* Escape character (+) */
	CFGMGR_CR_CHAR              = CFGMGR_SREG+3,    /* Line Termination character (CR) */
	CFGMGR_LF_CHAR              = CFGMGR_SREG+4,    /* Response Formatting character (LF) */
	CFGMGR_BS_CHAR              = CFGMGR_SREG+5,	/* Command Line Editing character (BS) */
	CFGMGR_BLIND_DIAL_WAIT_TIME = CFGMGR_SREG+6,    /* Time, in seconds, the modem waits before starting to dial 
													   after going off hook when blind dialing. */
	CFGMGR_CARRIER_WAIT_TIME    = CFGMGR_SREG+7,    /* Time, in seconds, the modem waits for carrier.
													   If enabled by country options, time, in seconds, 
													   the modem waits for dialtone after 'W' dial modifier */
	CFGMGR_PAUSE_DELAY_TIME     = CFGMGR_SREG+8,    /* Time, in seconds, the modem waits after ',' dial modifier */
	CFGMGR_CARDET_RESPONSE_TIME = CFGMGR_SREG+9,    /* Time, in 0.1 seconds modem waits before reporting carrier */
	CFGMGR_HANGUP_DELAY_TIME    = CFGMGR_SREG+10,	/* Time, in tenths of a second, the modem waits before 
													   hanging up after a loss of carrier */
	CFGMGR_DTMF_DURATION        = CFGMGR_SREG+11,   /* Duration, in milliseconds, of tones in DTMF dialing */
	CFGMGR_ESCAPE_PROMPT_DELAY  = CFGMGR_SREG+12,   /* Time, in fiftieths of a second, between receiving +++
													   and sending OK to DTE */
	CFGMGR_TEST_TIMER           = CFGMGR_SREG+18,   /* Time, in seconds, that the modem conducts a test (&T1) */
	CFGMGR_FLASH_DELAY_TIME     = CFGMGR_SREG+29,   /* Time, in hundredths of a second, the modem goes on-hook 
													   after flash (!) modifier */
	CFGMGR_INACTIVITY_TIME      = CFGMGR_SREG+30,   /* Time, in tens of seconds, the modem stays online when no
													   data is sent or received */
    CFGMGR_DATA_COMPRESSION     = CFGMGR_SREG+46,   /* Selection of compression */
	CFGMGR_EXTENDED_RESULT_CODES = CFGMGR_SREG+95,/* Bits to override some of the W control options */
    CFGMGR_SREG_LAST = CFGMGR_SREG+255,				/* S-register window end */


	/* Call Progress control codes */
	CFGMGR_DIALSTRING,								/* Pointer to a dial string     LPCSTR */
	CFGMGR_PULSE_DIAL_CONFIG,						/* Pulse dial parameters    */
	CFGMGR_TONE_DIAL_CONFIG,						/* Tone dial parameters     */
	CFGMGR_DIALTONE_WAIT_TIME,						/* Time in tenths of a second the modem waits for dialtone */
	CFGMGR_DIAL_MODE,								/* Dial mode (tone or pulse      DIAL_MODE */
	CFGMGR_AMPERP,									/* Value of the last at&p command */
	CFGMGR_USE_S7_WHEN_W,							/* if TRUE, use S7 for timeout after W modifier in dial string
													   if FALSE, use CFGMGR_DIALTONE_WAIT_TIME value */

    CFGMGR_CALL_PROGRESS_TONE_DEBOUNCE,				/* Debounce times for call progress tones */
	CFGMGR_CALL_MODE,     				            /* CALL_MODE*                   */
	CFGMGR_CALL_PROGRESS_FLAGS,						/* CALL_PROGRESS_FLAGS*         */
	CFGMGR_V8BIS_CONTROL,							/* V8BIS_OPERATION_CONTROL*		*/
	CFGMGR_V8BIS_RESULT,							/* PV8BIS_RESULT				*/
    CFGMGR_FIRST_CONNECTION_AFTER_TRAINING,         /* ??? */
    CFGMGR_PREFERRED_FLEX_VERSION,                  /* Preferred Flex version       */
    CFGMGR_V90_ENABLED,                             /* V.90 is enabled              */
    CFGMGR_V70_ALLOWED,                             /* V.70 is allowed              */

    /* AtParser Result Messages  - LPCSTR */
    CFGMGR_ATRESULT_OK,                            
    CFGMGR_ATRESULT_CONNECT,
    CFGMGR_ATRESULT_RING,
    CFGMGR_ATRESULT_NOCARRIER,
    CFGMGR_ATRESULT_ERROR,
    CFGMGR_ATRESULT_NODIALTONE,
    CFGMGR_ATRESULT_BUSY,
    CFGMGR_ATRESULT_NOANSWER,
    CFGMGR_ATRESULT_DELAYED,
    CFGMGR_ATRESULT_BLACKLISTED,
    CFGMGR_ATRESULT_FAX,
    CFGMGR_ATRESULT_DATA,
    CFGMGR_ATRESULT_FCERROR,

    /* MCR Messages  - LPCSTR */
    CFGMGR_MCR_B103,
	CFGMGR_MCR_B212,
	CFGMGR_MCR_V21,
	CFGMGR_MCR_V22,
	CFGMGR_MCR_V22B,
	CFGMGR_MCR_V23,
	CFGMGR_MCR_V32,
	CFGMGR_MCR_V32B,
	CFGMGR_MCR_V34,
	CFGMGR_MCR_K56,
	CFGMGR_MCR_V90,

    CFGMGR_ER_NONE,
    CFGMGR_ER_LAPM,
    CFGMGR_ER_ALT,

    CFGMGR_DR_ALT,
    CFGMGR_DR_V42B,
    CFGMGR_DR_NONE,


    /* ATIn Messages - LPCSTR */
    CFGMGR_ATMESSAGE_I0,
    CFGMGR_ATMESSAGE_I1,
    CFGMGR_ATMESSAGE_I2,
    CFGMGR_ATMESSAGE_I3,
    CFGMGR_ATMESSAGE_I4,
    CFGMGR_ATMESSAGE_I5,
    CFGMGR_ATMESSAGE_I6,
    CFGMGR_ATMESSAGE_I7,

    /* AT+GXX Messages  - LPCSTR    */
    CFGMGR_ATMESSAGE_MANUFACTURER,      /* AT+GMI responce  */
    CFGMGR_ATMESSAGE_MODEL,             /* AT+GMM responce  */
    CFGMGR_ATMESSAGE_REVISION,          /* AT+GMR responce  */
    CFGMGR_ATMESSAGE_SERIAL_NUM,        /* AT+GSN responce  */
    CFGMGR_ATMESSAGE_GOI,               /* AT+GOI responce  */
    CFGMGR_ATMESSAGE_CAPABILITIES,      /* AT+GCAP responce */

    /* DTE configuration    */
    CFGMGR_DTE_ECHO,                    /* UINT8            */
    CFGMGR_DTE_CONFIG,                  /* DTE_USER_CONFIG  */

    CFGMGR_RLSD_BEHAVIOR,               /* UINT8            */
    CFGMGR_DTR_BEHAVIOR,                /* UINT8            */

    /* Speaker Control */
    CFGMGR_SPEAKER_VOLUME,              /* UINT8            */
    CFGMGR_SPEAKER_CONTROL,             /* UINT8            */

    /* Pulse Dial Make/Break Ratio */
    CFGMGR_PULSE_MAKE_BREAK,            /* UINT8            */

    /* Ring burst frequencies */
    CFGMGR_RING_BURST,                  /* PRING_BURST_PARAMS */

    /* Answer tone detector params */
    CFGMGR_ANSWER_TONE_DETECTOR,        /* PANSWER_TONE_PARAMS */
    /* Bell answer (2225) tone detector params */
    CFGMGR_BELL_TONE_DETECTOR,          /* PANSWER_TONE_PARAMS */
    /* DTMF generator parameters */
    CFGMGR_DTMF_GENERATOR,              /* PDTMF_GEN_PARAMS */

    /* Modulation Report    */
    CFGMGR_MODULATION_REPORT,           /* UINT8            */

    /* Cadences */
    CFGMGR_CADENCE_BASE,
    CFGMGR_BUSY_TONE_CADENCE = CFGMGR_CADENCE_BASE,
    CFGMGR_RING_CADENCE,
    CFGMGR_REORDER_TONE_CADENCE,
    CFGMGR_SDIAL_TONE_CADENCE,
    CFGMGR_FAX_CALL_TONE_CADENCE,

    /* FAX Service Class 1 Configuration Values   */
    CFGMGR_FAX_AUTO_ANSWER,

    /*  OEM flags   */
    CFGMGR_OEM_FLAGS,                   /* OEMFlagStructure */



	/* Soft Modem Tone configurations */
	CFGMGR_TONE_PRIMARY_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_ALTERNATE_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_ATBEL_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_ATV25_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_1100_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_2130_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_2312_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_2750_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_TONE_2912_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICETONEACALLPROG_PARAMS,		/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICETONEB_1100_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICETONEC_1300_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICETONEC_2100_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICETONEB_2225_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_V8BTONE_2100_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_V8BTONE_2225_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_CI_CENTER_TONEB_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_CI_SIDE_TONEC_PARAMS,			/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICEVIEW_TONEC_2912_PARAMS,		/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICEVIEW_TONEB_2312_PARAMS,		/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICEVIEW_TONEB_2750_PARAMS,		/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICEVIEW_TONEA_2130_PARAMS,		/* SINGLETONEDETECT*	*/	
	CFGMGR_VOICEVIEW_TONEA_NOT_ST_PARAMS,	/* SINGLETONEDETECT*	*/	
	CFGMGR_TONEC_1650_PARAMS,				/* SINGLETONEDETECT*	*/	
	CFGMGR_CReSEG1_2002PARAMS,				/* SINGLETONEDETECT*	*/	

	// Tone generator - constant configurations saved in Configuration manager
	CFGMGR_TONE_GEN_V25CALL,				/* TONEGEN_PARAMS*		*/
	CFGMGR_TONE_GEN_CNG,					/* TONEGEN_PARAMS*				*/
	CFGMGR_TONE_GEN_CED,					/* TONEGEN_PARAMS*				*/
	CFGMGR_TONE_GEN_CI,						/* TONEGEN_PARAMS*				*/

    /** HW - buffer switch delay. **/
    CFGMGR_BUFFERS_DELAY,                   /* UINT16*. */
   	CFGMGR_PCI_DEVICE_ID,
	CFGMGR_PCI_VENDOR_ID,

    CFGMGR_OEM_HWDATA,                   /* HW_DATA */
    CFGMGR_OEM_DAATYPE,                   /* BYTE */
	CFGMGR_OEM_SMARTDAA_PARAMS         ,   /*  CAESAR_PARAMS */
	CFGMGR_HW_ADAPTER_TYPE,                
 
	/* country parametrs for CtryPrmsStruct */
    CFGMGR_CTRY_TX_LEVEL         ,	/* CntryTxlevelStructure            */
    CFGMGR_CTRY_RELAYS           ,    /* Country Relays	                */
    CFGMGR_CTRY_T35CODE          ,    /* Country T35Code                */
	CFGMGR_CTRY_NAME             ,    /* Country Name                   */
	CFGMGR_CTRY_INTCODE          ,    /* Country Name                   */
	CFGMGR_CTRY_PULSE            ,    /* CntryPulseStructure            */
	CFGMGR_CTRY_RING             ,    /* CntryRingStructure             */
	CFGMGR_CTRY_SREG             ,
	CFGMGR_CTRY_DTMF             ,    /* CntryDTMFStructure             */
	CFGMGR_CTRY_RLSD             ,    /* CntryRLSDStructure             */
	CFGMGR_CTRY_TONE             ,    /* CntryToneStructure             */
	CFGMGR_CTRY_CADENCE          ,    /* CntryCadenceStructure          */
	CFGMGR_CTRY_THRESHOLD        ,    /* CntryThresholdStructure        */
	CFGMGR_CTRY_TIMING           ,    /* CntryTimingStructure           */ 
	CFGMGR_CTRY_BLACKLISTING     ,    /* CntryBlacklistingStructure     */ 
	CFGMGR_CTRY_CALLERID         ,    /* CntryCallerIDStructure         */ 
	CFGMGR_CTRY_FLAGS            ,    /* CntryFlagStructure             */ 
	CFGMGR_CTRY_SPEEDADJUST      ,    /* CntryAgressSpeedIndexStructure */ 
 
    CFGMGR_LAST

} CFGMGR_CODE;

 
typedef struct tagDTE_USER_CONFIG
 
{
    UINT8       bQuiet;     /* DTE result codes disabled */
    UINT8       bVerbose;   /* Long result form */
    UINT8       bLevel;     /* Result codes level */
    UINT8       bConnect;   /* Connect Message Form */

} DTE_USER_CONFIG, *PDTE_USER_CONFIG;

typedef struct PACKED_ATTRIB tagMS_USER_CONFIG
{
   MODULATION_TYPE	eModulation;
   BOOL				bAutomode;
   UINT32			dwMinTxSpeed;
   UINT32			dwMaxTxSpeed;
   UINT32			dwMinRxSpeed;
   UINT32			dwMaxRxSpeed;

} MS_USER_CONFIG, *PMS_USER_CONFIG;

 
typedef struct tagDS_USER_CONFIG 
{
   UINT32	dwCompressDict;
   UINT32	dwCompressStr;
   UINT32	dwCompressDir;
   UINT32	dwCompressNeg;

} DS_USER_CONFIG, *PDS_USER_CONFIG;

typedef struct tagEC_USER_CONFIG
{
   UINT32   dwOrgReq;
   UINT32   dwOrgFbk;
   UINT32   dwAnsFbk;
   BOOL     bV42SkipToXID;
   UINT32   dwSkipV42DetPhase;

} EC_USER_CONFIG, *PEC_USER_CONFIG;

typedef enum
{
	TONE,
	PULSE
} DIAL_MODE;


typedef struct
{
	UINT16	DialToneStable,
			WDialToneStable,
			AnswerToneStable,
			CallProgressToneStable;
} TONE_DEBOUNCE_CONFIG, *PTONE_DEBOUNCE_CONFIG;

typedef struct 
{
	UINT8 v8o,		/* 1 = enable +A8x indicators, 6 = disable +A8x (originate) */
		  v8a,		/* 1 = enable +A8x indicators, 5 = disable +A8x (answer) */
		  v8c,		/* value of V.8 CI signal call function */
		  v8b;		/* 0 = disable V.8bis, 1 = DCE-controlled V.8bis, 2 = DTE-controlled V.8bis */
/*	PCHAR cfrange,	// not supported */
/*		  protrange;// not supported */
} V8BIS_OPERATION_CONTROL, *PV8BIS_OPERATION_CONTROL;

typedef enum 
{ 
	V8BIS_FAILED, 
	V8BIS_SUCCESSFUL, 
	V8BIS_MODE_NOT_SUPPORTED
} V8BIS_STATE;

typedef struct
{
    UINT8	    NS_FlexVersion;                     /*  NS - Flex Version Number */
	UINT8	    bRemoteIsConexant;
    UINT8	    bK56UseUlaw;
    UINT8	    bK56flexNegotiated;
    UINT8	    bV90InNonStdFld;
    UINT8	    bV90InStdFld;
    UINT8	    bV70_Enabled;
    V8BIS_STATE eState;
} V8BIS_RESULT, *PV8BIS_RESULT;

typedef struct 
{
  /* Flag0 */
  int fAltDialToneFilter: 1;
  int fAltCallProgressFilter: 1;
  int fAltWToneFilter: 1;
  int fAltWAfterIntCodeFilter: 1;
  int fFlag0Spare4: 1;
  int fFlag0Spare5: 1;
  int fFlag0Spare6: 1;
  int fFlag0Spare7: 1;

  /* Flag1 */
  int fEnforceDialTone: 1;
  int fEnforceCallingToneorCI: 1;
  int fEnforceGuardTone: 1;
  int fEnforceBusyTone: 1;
  int fUseS7whenW: 1;
  int fHangupOnCallWaiting: 1;
  int fFlag1Spare6: 1;
  int fFlag1Spare7: 1;

  /* Flag2 */
  int fDisableATH1: 1;
  int fDisablePulseAfterTone: 1;
  int fAllowPulseDialing: 1;
  int fAllowDTMFabcd: 1;
  int fEnableBlacklisting: 1;
  int fLongToneIsBusy: 1;
  int fSelectUlaw: 1;
  int fNoBellMode: 1;

  /* Flag3 */
  int fSwissComma: 1;		/*Swiss approval do not want first comma in dial string*/
  int fFlag3Spare1: 1;
  int fFlag3Spare2: 1;
  int fFlag3Spare3: 1;
  int fFlag3Spare4: 1;
  int fFlag3Spare5: 1;
  int fFlag3Spare6: 1;
  int fFlag3Spare7: 1;
} CALL_PROGRESS_FLAGS, *PCALL_PROGRESS_FLAGS;

/* Structure passed with CFGMGR_RING_BURST */
typedef struct tagRingBurstParams {
    UINT16  m_nMinFreq;				/* in Hz */
    UINT16  m_nMaxFreq;				/* in Hz */
} RING_BURST_PARAMS, *PRING_BURST_PARAMS;

/* Structure passed with CFGMGR_ANSWER_TONE_DETECTOR/CFGMGR_BELL_TONE_DETECTOR */
typedef struct tagAnswerToneParams {
    UINT16  m_wCenterFrequency;
    UINT16  m_wBandwidth;
    short   m_nAmplitude;			/* normed to 32768 */
} ANSWER_TONE_PARAMS, *PANSWER_TONE_PARAMS;

/* Structure passed with CFGMGR_DTMF_GENERATOR */
typedef struct tagDTMFGenParams {
	UINT16  m_wDigitDuration;		/* in ms */
	UINT16  m_wPauseDuration;		/* in ms */
	short	m_nHighBandAmplitude;	/* normed to 32768 */
	short	m_nLowBandAmplitude;	/* normed to 32768 */
} DTMF_GEN_PARAMS, *PDTMF_GEN_PARAMS;

typedef enum
{
	UD_DISPLAY_FALSE,
	UD_DISPLAY_TRUE,
	UD_DISPLAY_REBOOT
} UD_DISPLAY;

typedef enum
{
	CauseUndefined			= 0x0,
	NoPreviousCall			= 0x1,
	CallInProgress			= 0x2,
	CallWaiting				= 0x3,
	Delayed					= 0x4,
	InacTimerExpired		= 0x19,
	DTRDrop					= 0x20,
	BlackListed				= 0x29,
	ExtOffhook				= 0x2B,
	S7Expired				= 0x2C,
	LoopCurrentInterrupted	= 0x2E,
	NoDialTone				= 0x2F,
	Voice					= 0x30,
	ReorderTone				= 0x31,
	CarrierLost				= 0x3C,
	TrainingFailed			= 0x3D,
	NoModinCommon			= 0x3E,
	RetrainedFail			= 0x3F,
	GSTNCleardown			= 0x41,
	FaxDetected				= 0x42,
	AnykeyAbort				= 0x50,
	ATH						= 0x51,
	ATZ						= 0x52,
	FrameReject				= 0x5A,
	NoECEstablished			= 0x5B,
	ProtViolation			= 0x5C,
	n400Exceeded			= 0x5D,
	NegotiatFailed			= 0x5E,
	DiscontFrame			= 0x5F,
	SabmeFrame				= 0x60,
	LostSync				= 0x64,
	DLG						= 0x65	/* added for dlg support */
} CALL_TERMINATION_CAUSE;

typedef struct tagATPoundUDCommand
{
	UD_DISPLAY	cUDDisplay;					/*Flag used to detemine if to display #UD/#UG*/
	UINT8		cUDCallSetup;				/*0x1, Table 2*/
	UINT8		cUDMultMediaMode;			/*0x2, Table 3*/
	UINT8		cUDDTEDCEmode;				/*0x3, Table 4*/

	char		sUDV8CM[20];				/* 0x4 V8_CM*/
	char		sUDV8JM[20];				/* 0x5 V8_JM*/

	UINT8		cUDRXdb;					/*0x10, 2 Digits in Hex*/
	UINT8		cUDTXdb;					/*0x11, 2 Digits in Hex*/
	UINT8		cUDSNratio;					/*0x12, 2 Digits in Hex*/
	UINT8		cUDMSE;						/*0x13 Normalized Mean Squared error*/
	UINT8		cUDNearEchoLoss;			/*0x14 near echo loss*/
	UINT8		cUDFarEchoLoss;				/*0x15 far echo loss*/
	UINT16		wUDFarEchoDelay;			/*0x16 far echo delay*/
	UINT8		cUDRoundTripDelay;			/*0x17 round trip delay*/
	UINT32		lV34InfoBits;				/*0x18 status */
   
	UINT8		cUDTXCarrierNegotiation;	/*0x20, Table 6*/
	UINT8		cUDRXCarrierNegotiation;	/*0x21, Table 6*/
	UINT16		wUDTXSymbol;				/*0x22, 4 Digits in Hex*/
	UINT16		wUDRXSymbol;				/*0x23, 4 Digits in Hex*/
	UINT16		wUDTXCarrierFreq;			/*0x24, 4 Digits in Hex*/
	UINT16		wUDRXCarrierFreq;			/*0x25, 4 Digits in Hex*/
	UINT16		wUDFirstTXrate;				/*0x26, 4 Digits in Hex*/
	UINT16		wUDFirstRXrate;				/*0x27, 4 Digits in Hex*/

	UINT8		cUDCarrierLossCount;		/*0x30, 2 Digits in Hex */
    UINT8		cUDRateRenegReqCount;       /*0x31, 2 Digits in Hex, (half) */
    UINT8		cUDRateRenegDetCount;       /*0x31, 2 Digits in Hex, (half) */
    UINT8		cUDRetrainReqCount;         /*0x32, 2 digits in Hex  */
    UINT8		cUDRetrainDetCount;         /*0x33  2 digits, Retrains granted */
    UINT16		wUDLastTXrate;              /*0x34, 4 digits in Hex  */
    UINT16		wUDLastRXrate;              /*0x35, 4 digits in Hex  */

    UINT8		cUDProtocolNegotiation;     /*0x40, table 4 */
    UINT16		wUDMaxFrameSize;            /*0x41, 3 digits */
    UINT8		cUDECLinkTimeout;           /*0x42, 1 digits */
    UINT8		cUDECLinkNAK;               /*0x43, 1 digits */
    UINT8		cUDCompressionNegotiation;  /*0x44, table 5 */
    UINT16		cUDCompressionDictSize;     /*0x45, 4 digits */

    UINT8		cUDTXFlowControl;           /*0x50, 1 digits */
    UINT8		cUDRXFlowControl;           /*0x51, 1 digits */
    UINT32		lUDTXCharFromDTE;           /*0x52, 8 digits */
    UINT32		lUDRXCharToDTE;             /*0x53, 8 digits */
    UINT16		wUDTXCharLost;              /*0x54, 4 digits */
    UINT16		wUDRXCharLost;              /*0x55, 4 digits */
    UINT32		lUDTXFrameCount;            /*0x56, 8 digits */
    UINT32		lUDRXFrameCount;            /*0x57, 8 digits */
    UINT32		lUDTXFrameErrorCount;       /*0x58, 8 digits */
    UINT32		lUDRXFrameErrorCount;       /*0x59, 8 digits */

    CALL_TERMINATION_CAUSE	cUDTermination; /*0x60 Tables 8-9   */
}ATPoundUD;

/*****************************************************************
OEM & COUNTRY specific parameters, should be loaded from NVRAM
BEGIN
*****************************************************************/
/* COUNTRY PARAMETRERS  */

#define MAX_INTERVALS				4
#define MAX_OEM_STR_LEN				80
/* Number of S-registers limited by entries in the INF file */
#define NUM_LIMITED_SREGS			10
#define NUM_FULL_SREGS              40

#if ( OS_TYPE != OS_LINUX )
#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(1)		/* must be pack */
#endif
#endif

/* Transmit Level */
typedef struct tagTxlevel {
	UINT8	TxDataLevelMin;
	UINT8	TxDataLevelMax;
	UINT8	TxDataLevelDefault;
	UINT8	TxFaxLevelMin;
	UINT8	TxFaxLevelMax;
	UINT8	TxFaxLevelDefault;
	UINT8	TxVoiceLevelMin;
	UINT8	TxVoiceLevelMax;
	UINT8	TxVoiceLevelDefault;
	char	TxLvlAdj;							/* can be + or - */
	UINT8	LowDialLevel;
	UINT8	HighDialLevel;
} CntryTxlevelStructure;

 
 
/* Pulse Dial Parameters */
typedef struct PACKED_ATTRIB tagPulse {
	UINT8	PulseDialMode;
	UINT8	PulseMapAmperP0;/*Maps the &P values */
	UINT8	PulseMapAmperP1;
	UINT8	PulseMapAmperP2;
	UINT8	PulseMapAmperP3;
	char	PulseMakeOffset;					/* can be +/- */
	char	PulseBreakOffset;					/* can be +/- */
	UINT8	PulseSetupTime;
	UINT8	PulseClearTime;
	UINT16	PulseInterd;
	UINT16	LineMuteDelay;						/*VRO: Line mute delay */
} CntryPulseStructure;

 
/* Ring Detection Parameters */
typedef struct PACKED_ATTRIB tagRing {
	UINT8	RingMaxFrequency;
	UINT8	RingMinFrequency;
	UINT16	RingStable;
	UINT16	MinTimeBeforeAnswering;
	UINT16	MinDelayBtwnRings;
	UINT16	MaxDelayBtwnRings;
} CntryRingStructure;

/* DTMF Dial Parameters*/
typedef struct tagDTMF {
	UINT16	DTMFOnTime;
	UINT16	DTMFInterdigit;   
} CntryDTMFStructure;

typedef struct PACKED_ATTRIB FilterParamTAG {
	UINT16	FilterType;
	UINT16	Biquad1[5];
	UINT16	Biquad2[5];    
	UINT16	LpFBK;
	UINT16	LpGain;
	UINT16	ThreshU;
	UINT16	ThreshL;
	UINT16	Biquad1_PreF[5];
	UINT16	Biquad2_PreF[5];
	BOOL	SqDisState;
} FilterParam, *ptrFilterParam;

/* Filter Parameters */
typedef struct tagFilter {
	FilterParam		Primary;
	FilterParam		Alternate;
	FilterParam		VoiceToneACallProgress;
} CntryFilterStructure;

/* Thresholds Parameters */
typedef struct PACKED_ATTRIB tagThreshold {
	UINT16		DialThresh;
	UINT16		AltDialThresh;
	UINT16		WDialThresh;
	UINT16		AltWDialThresh;
	UINT16		ProgThresh;
	UINT16		AltProgThresh;
	UINT16		DTMFRxThresh;
	UINT16		RingThreshold;			/* Add soft ring threshold set to 0 if not use */
	short int	RingBalance;			/* Add soft ring threshold compensation slope, set to 0 if not use*/
	UINT16      CIDThresh;
} CntryThresholdStructure;

/* RLSD Threshold Adjustment*/
typedef struct tagRLSD {
	UINT32		XrthOffset;				/* can be + or -*/
} CntryRLSDStructure;

/* Tone Detection Parameters*/
typedef struct PACKED_ATTRIB tagTone {
	UINT16		DialStable;
	UINT16		WDialStable; 
	UINT16		AnswerStable;
	UINT16		ProgressStable;
	UINT8		DialtoneWaitTime;
} CntryToneStructure;

/* Timing Parameter*/
typedef struct tagTiming {
	UINT16		InterCallDelay1;		/* Delay when same number dialed after outgoing call */
	UINT16		InterCallDelay2;		/* Delay when different number dialed after outgoing call */
	UINT16		InterCallDelay3;		/* Delay after incoming call */
	UINT16		BillingDelay;           /*Delay between ATA and start of v8bis */
} CntryTimingStructure;

typedef struct PACKED_ATTRIB tagCadPrm {
	struct {
		UINT32	lMin;
		UINT32	lMax;
	} Interval[MAX_INTERVALS];
	UINT32		lNumIntervalsNeeded;
} CadPrm;

/* TONE CADENCE */
typedef struct PACKED_ATTRIB tagCadence {
	UINT8		ToneCadence_NumberOfPhases;
	CadPrm		DialtoneParams;
	CadPrm		BusyParams;
	CadPrm		RingbackParams;
	CadPrm		CongestionParams;
} CntryCadenceStructure;

/* Blacklisting FLAGS */
typedef struct PACKED_ATTRIB tagBL_Flags {
	int		fPermanantBlst: 1;
	int		fResetOnSuccess: 1;
	int		fDistictFailures: 1;
	int		fFlag0Spare3: 1;
	int		fFlag0Spare4: 1;
	int		fFlag0Spare5: 1;
	int		fFlag0Spare6: 1;
	int		fFlag0Spare7: 1;
} BLFlagStructure;

/* Blacklisting Parameters */
typedef struct PACKED_ATTRIB tagBlacklisting {
	UINT8			BlstAction_NoDialTone;
	UINT8			BlstAction_KeyAbort;
	UINT8			BlstAction_Busy;
	UINT8			BlstAction_NoConnection;
	UINT8			BlstAction_NoAnswer;
	UINT8			BlstAction_VoiceAnswer;
	UINT16			BlackListingDelay1;			/* InterCall Delay upon Failure when redialing same number */
	UINT16			BlackListingDelay2;			/* InterCall Delay upon Failure when redialing different number */
	UINT16			BlackListingDelay3;			/* Method 2 Delay */
	UINT16			BlackListingDelay4;			/* Method 3 Delay  */
	UINT16			BlackListingCount1;			/* Method 2 # of Failures  */
	UINT16			BlackListingCount2;			/* Method 3 # of Failures  */
	BLFlagStructure	BlstFlags;
} CntryBlacklistingStructure;

/* CallerID Parameter */
typedef struct tagCallerID {
	UINT8		Cid_TYPE;
} CntryCallerIDStructure;

/* Flag Control */
typedef struct tagFlags {
	/* CountryFlag0 */
	int		fAltDialToneFilter: 1;
	int		fAltCallProgressFilter: 1;
	int		fAltWToneFilter: 1;
	int		fAltWAfterIntCodeFilter: 1;
	int		fFlag0Spare4: 1;
	int		fFlag0Spare5: 1;
	int		fFlag0Spare6: 1;
	int		fFlag0Spare7: 1;
	/* CountryFlag1 */
	int		fEnforceDialTone: 1;
	int		fEnforceCallingToneorCI: 1;
	int		fEnforceGuardTone: 1;
	int		fEnforceBusyTone: 1;
	int		fUseS7whenW: 1;
	int		fHangupOnCallWaiting: 1;
	int		fFlag1Spare6: 1;
	int		fFlag1Spare7: 1;
	/* CountryFlag2 */
	int		fDisableATH1: 1;
	int		fDisablePulseAfterTone: 1;
	int		fAllowPulseDialing: 1;
	int		fAllowDTMFabcd: 1;
	int		fEnableBlacklisting: 1;
	int		fLongToneIsBusy: 1;
	int		fSelectUlaw: 1;
	int		fNoBellMode: 1;
	/* CountryFlag3 */
	int		fSwissComma: 1;					/* Swiss approval do not want first comma in dial string */
	int		fFlag3Spare1: 1;
	int		fFlag3Spare2: 1;
	int		fFlag3Spare3: 1;
	int		fFlag3Spare4: 1;
	int		fFlag3Spare5: 1;
	int		fFlag3Spare6: 1;
	int		fFlag3Spare7: 1;
} CntryFlagStructure;

/* Agress speed Parameter */
typedef struct tagAgressSpeedIndex {
	UINT8	cV90AgressSpeedIndex;
	UINT8	cK56AgressSpeedIndex;
	UINT8	cV34AgressSpeedIndex;
} CntryAgressSpeedIndexStructure;

typedef struct tagCtryPrmsStruct {
	UINT16							T35Code;							/* T.35 Country Identification */
	char							cInter[MAX_OEM_STR_LEN];			/* Country Name */
	char							cIntCode[MAX_OEM_STR_LEN];			/* Country International Access code */
	CntryTxlevelStructure			Txlevel;							/* Transmit Level */
	UINT16							Relays[DEVMGR_LAST_RELAY_ENTRY];			/* Relay Control Parameters */
	CntryPulseStructure				Pulse;								/* Pulse Dial Parameters */
	CntryRingStructure				Ring;								/* Ring Detection Parameters */
	UINT8							SRegLimits[NUM_LIMITED_SREGS][4];	/* S Register Limiting */
	CntryDTMFStructure				DTMF;								/* DTMF Dial Parameters */
	CntryFilterStructure			Filter;								/* Filter Parameters */
	CntryThresholdStructure			Threshold;							/* Thresholds Parameters */
	CntryRLSDStructure				RLSD;								/* RLSD Threshold Adjustment */
	CntryToneStructure				Tone;								/* Tone Detection Parameters */
	CntryTimingStructure			Timing;								/* Timing Parameter */
	CntryCadenceStructure			Cadence;							/* TONE CADENCE */
	CntryBlacklistingStructure		Blacklisting;						/* Blacklisting Parameters */
	CntryCallerIDStructure			CallerID;							/* CallerId Control */
	CntryFlagStructure				Flags;								/* Flag Control */
	CntryAgressSpeedIndexStructure	AgressSpeedIndex;					/* Agress Speed Parameter */
} CtryPrmsStruct;

/* OEM PARAMETERS */

typedef struct PACKED_ATTRIB tagOEM_Flags {
	/* OEMFlag0 */
	int		fUseTIES: 1;
	int		fAnalogSpeaker: 1;
	int		fDataFaxRemoteTAM: 1;
	int		fDataFaxVoiceView: 1;
	int		fLCSPresent: 1;
	int		f3VoltIA: 1;
	int		fRemHangupPresent: 1;
	int		fSpkMuteHWPresent: 1;
	/* OEMFlag1 */
	int		fReadCountryFromSwitch: 1;
	int		fLegacy: 1;						/* Add fLegacy flags (ACF compatibility cmd) */
	int		fPME_Enable: 1;					/* enable D3 sleep and arming PME */
	int		fAlternateConnectMSG: 1;
	int		fCountryNoneSelect: 1;			/* Option whether to allow NONE in country select tab */
	int		fSpkMuteHWPolarity: 1;
	int		fLocalSpkBoostTAM: 1;			/* ON = Set IA Spk Output to maximum level, OFF = pickup default value  */
	int		fMicSpkControl: 1;				/* ON = allow +VGM, +VGS; OFF = not allow +VGM, +VGS & load DSVD_Default values */
	/* OEMFlag2 */
	int		fNEC_ACPI: 1;					/* NEC special handling of APM/ACPI */
	int		fDisForceLAPMWhenNoV8bis: 1;	/* Disable forcing LAPM when V.8bis fails in V.90 */
	int		fDosSupportDisabled: 1;			/* indicates if DOS support checkbox is toggled on/off (1=OFF) */
	int		fDosCheckBoxSupport: 1;			/* indicates if DOS support checkbox is shaded/unshaded (0=Shaded) */
	int		fCIDHandsetMode: 1;				/* ON = special local handset handling based on +VCID setting. */
	int		fExtOffHookHWPresent: 1;		/* ON = hardware is able to detect extension off hook */
	int		fLAN_Modem_Support: 1;			/* ON = customize for lan/modem */
	int		fPortCloseConnected: 1;			/* ON = maintain modem connection on PortClose */
	/* OEMFlag3 */
	int		fFullGPIO: 1;					/* ON=full control to GPIO with AT-GPIO command */
	int		fD3CIDCapable: 1;				/* does DAA support d3 caller ID circuitry */
	int		fLineInUsed: 1;					/* When 1 enable customized line in used detection before dialing */
	int		fV42ThrottleDisable: 1;			/* When one, disable V.42 Rx throttle */
	int		fxDSLCombo: 1;					/* xDSL modem only, 1 = combo board */
	int		fV23AnswerDis: 1;
	int		fDialSkipS6: 1;
	int		fFxCallCadFlag: 1;
} OEMFlagStructure;

typedef struct tagOEM_Filter {
	FilterParam		Tone1100;
	FilterParam		V8bToneC2100;
	FilterParam		V8bToneB2225;
	FilterParam		VoiceToneB1100;
	FilterParam		VoiceToneC1300;
	FilterParam		VoiceToneC2100;
	FilterParam		VoiceToneB2225;
} OEMFilterStructure;

typedef struct tagModulation {
	UINT16		Org;
	UINT16		Ans;
} Modulation;

typedef struct tagOEM_Threshold {
	Modulation		V21;
	Modulation		V21fax;
	Modulation		V23;
	Modulation		V22;
	Modulation		V22b;
	Modulation		V32;
	Modulation		V32b;
	Modulation		V34;
	Modulation		K56;
	Modulation		V90;
	Modulation		V27;
	Modulation		V29;
	Modulation		V17;
} OEMThresholdStruct;

// For soft modem tone detector params - 


typedef struct tagSingleTone
{
	UINT16  CenterFreq;	   // Hz
	UINT16  Bandwidth;		// Hz
	UINT32 ResponseTime;	// Millisec
	short OnThreshold;	// dBm
	short OffThreshold;	// dBm
   UINT32 OnDebounce;    // Millisec
   UINT32 OffDebounce;   // Millisec
} SINGLETONEDETECT, *PSINGLETONEDETECT;

typedef struct CNTRY_TONEPARAMS_TAG {
  SINGLETONEDETECT Primary;
  SINGLETONEDETECT Alternate;
  SINGLETONEDETECT VoiceToneACallProgress;
} CNTRY_TONEPARAMS_T, *PCNTRY_TONEPARAMS_T;
typedef struct OEM_TONEPARAMS_TAG{
  SINGLETONEDETECT Tone1100;
  SINGLETONEDETECT V8bToneC2100;
  SINGLETONEDETECT V8bToneB2225;
  SINGLETONEDETECT VoiceToneB1100;
  SINGLETONEDETECT VoiceToneC1300;
  SINGLETONEDETECT VoiceToneC2100;
  SINGLETONEDETECT VoiceToneB2225;
}OEM_TONEPARAMS_T, *POEM_TONEPARAMS_T;

typedef struct CONSTANT_TONEPARAMS_TAG{
  SINGLETONEDETECT ToneATBel;
  SINGLETONEDETECT ToneATV25;
  SINGLETONEDETECT CICenterFreq;
  SINGLETONEDETECT CISideBand;
  SINGLETONEDETECT ToneC_2912;
  SINGLETONEDETECT ToneB_2312;
  SINGLETONEDETECT ToneB_2750;
  SINGLETONEDETECT ToneA_2130;
  SINGLETONEDETECT ToneA_NOT_ST;
  SINGLETONEDETECT ToneC_1650;
  SINGLETONEDETECT Tone_CReSEG1_2002;
}CONSTANT_TONEPARAMS_T, *PCONSTANT_TONEPARAMS_T;

// Dual/Single Tone generator struct
typedef struct
{
	UINT16 freq1; // Hz
	UINT16 freq2;
	UINT32 OnTime;
	UINT32 OffTime;
   BOOL  bRepeatedTone;
} TONEGEN_PARAMS, *PTONEGEN_PARAMS;

typedef struct CONSTTONEGENPARAMS_TAG
{
	TONEGEN_PARAMS	V25CallTone	;
	TONEGEN_PARAMS	CNGTone		;
	TONEGEN_PARAMS	CEDTone		;
}CONSTTONEGENPARAMS_T, *PCONSTTONEGENPARAMS_T;

 
#define DEFAULT_DC_LOOP_POINTS	5
#define DEFAULT_DC_LOOP_ENTRIES	5
#define IMPEDANCE_VALUES_NUM	4
#define NUM_OF_RESISTANCES		5	
 
 
#if ( OS_TYPE != OS_LINUX )
#if ( USE_PRAGMA_PACK == 1 )
#pragma pack()
#endif
#endif

/*****************************************************************
OEM & COUNTRY specific parameters, should be loaded from NVRAM
END
*****************************************************************/

#endif      /* #ifndef __CONFIGCODES_H__ */
