
extern UINT32 NumOfCodes;
extern char TotalBuffer[64*1024];
extern UINT32 TotalOffset;
extern size_t NumOfCountries;
extern size_t CurrenCtryPosition;
 
 
typedef struct tagIndexTable
{
	CFGMGR_CODE CfgCode;
	UINT32		Offset;
	size_t		Size;
} INDEX_TABLE, *PINDEX_TABLE;

typedef struct tagDirectConvTable
{
	char *InfString;
	CFGMGR_CODE CfgCode;
} DIRECT_CONV_TABLE, *PDIRECT_CONV_TABLE;

 
 
typedef UINT32  (*PCONVFUNC)(PVOID,PVOID,PINDEX_TABLE);
typedef UINT32  (*PCOUNTRY_CONVFUNC)(BOOL *,PINDEX_TABLE,PVOID,PVOID);
 
 
typedef struct tagInDirectConvTable
{
	char *InfString;
	PCONVFUNC pConvFunc;
}  INDIRECT_CONV_TABLE, *PINDIRECT_CONV_TABLE;

typedef struct tagInDirectCountryConvTable
{
	char *InfString;
	PCOUNTRY_CONVFUNC pConvFunc;
}  INDIRECT_COUNTRY_CONV_TABLE, *PINDIRECT_COUNTRY_CONV_TABLE;
 
 
BOOL ConvertInfDirect(PVOID, PDIRECT_CONV_TABLE, PINDEX_TABLE, char *); 
BOOL ConvertInfInDirect(PVOID, PINDIRECT_CONV_TABLE, PINDEX_TABLE); 
BOOL ConvertInfCountryInDirect(PVOID, PINDIRECT_COUNTRY_CONV_TABLE, PINDEX_TABLE); 
 
size_t GetCountryNum( PVOID  );
size_t GetCurrentCountryPosition( PVOID  );
UINT16 GetCountryCode( PVOID );
 
void   BuildCountryKey(char *, char *);
void BuildKeyBuf(char *, char *);
 
void GetValue(char *, char *);
size_t GetData(char *, char *);
 
UINT32 ProcessMSSTR(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessMS(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessSregs(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessOemFlags(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessOemHwData(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessOemDaaType(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessOemSmartDaaParams(PVOID,PVOID,PINDEX_TABLE);
UINT32 ProcessHwAdapterType(PVOID,PVOID,PINDEX_TABLE);
 


UINT32 ProcessCtryNAME(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryINTCODE(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryTXLEVEL(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryRELAYS(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryT35CODE(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryPULSE(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryRING(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtrySREG(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryDTMF(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryRLSD(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryTONE(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryCADENCE(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryTHRESHOLD(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryTIMING(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryBLACKLISTING(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryCALLERID(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtryFLAGS(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
UINT32 ProcessCtrySPEEDADJUST(BOOL *,PINDEX_TABLE ,PVOID ,PVOID);
