/*----------------------------------------------------------------------------
 *
 * The information contained in this file is confidential and 
 * proprietary to Conexant Systems Inc.
 * No part of this file may be reproduced or distributed, in any form
 * or by any means for any purpose, without the express written
 * permission of Conexant Systems Inc.
 *
 * Copyright (C) 1996-2001 Conexant Systems Inc. 
 * All rights reserved.
 *
 *----------------------------------------------------------------------------
 *
 * File: cpucnt.inl
 * cpucnt.inl - get the cpu cycles counter.
 *
 *----------------------------------------------------------------------------
 */
 
#ifndef __CPUCNT_INL__
#define __CPUCNT_INL__


static __inline volatile unsigned long ReadCpuCnt(void)
{
/*  static volatile unsigned long CpuCnt; */
    unsigned long CpuCnt;

#if ( COMPILER == CMP_MSDEV )
	__asm {
		push	edx
		push	eax
		_emit byte ptr 0fh;
		_emit byte ptr 31h;

//		mov dword ptr [CpuCnt], edx;
		mov dword ptr [CpuCnt], eax;	/* store only the LS */
		pop		eax
		pop		edx
	}
#else
    asm volatile
	( "\n"
	  /* no need to push and pop - compiler is instructed that eax and edx
	     are used within this asm, and it will handle them accordingally!*/
	  ".byte 0x0f, 0x31\n"
	  /*  "	movl %%edx, %0\n" */  /* no need to store the MSB */
	  /*"	movl %%eax, %0\n" */  /* no need to store result -
	                                 =a (CpuCnt) means CpuCnt is in eax! */
	  : "=a" (CpuCnt) : : "edx" );
#endif

    return CpuCnt;

}  /* ReadCpuCnt */


#endif /* __CPUCNT_INL__ */
