/*************************************************************************

  File Name: CtrlCode.h

  File Description:
  This file include control codes of data stored in configuration manager
  and NVM manager. The codes and types in this file are now only for example, 
  since the config codes are implementation specific.

  *************************************************************************/

#ifndef __CTRL_CODE_H__
#define __CTRL_CODE_H__
#include "comtypes.h"

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(push,1)   // Packing compatible with WinAC
#endif

#define MAX_DIAL_STRING_LEN 50

typedef enum {
	COMMON_CONTROL_BASE = 0,
	CONTROL_DATA_COMPRESSION,			/* DATA_COMPRESSION_INFO*		*/
	CONTROL_DIAL_PARAMS,				/* DIAL_PARAMS*                 */
	CONTROL_MODULATION,					/* MODULATION_TYPE  * ModType   */
	CONTROL_AUTOMODE,					/* BOOL* 						*/
	CONTROL_CALL_MODE,     				/* CALL_MODE*                   */
	CONTROL_DUPLEX_MODE,				/* UINT32* RxTxModeMask          */



} CONTROL_CODE;


typedef enum {
	DTMF,
	PULSE,
} DIAL_MODE;


typedef struct DIAL_PARAMS_TAG{
	char		DialString[MAX_DIAL_STRING_LEN]; 
	DIAL_MODE	DialMode;
} DIAL_PARAMS_T, *PDIAL_PARAMS_T; 

typedef struct DATA_COMPRESSION_INFO_TAG{
	int DictionarySize;
	int MaxStringLength;
}DATA_COMPRESSION_INFO_T, *PDATA_COMPRESSION_INFO_T;

typedef enum {
	CALLER_MODE,
	ANSWER_MODE,
} CALL_MODE;

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(pop)   // Packing compatible with our VXDs
#endif

#endif /* __CTRL_CODE_H__ */
