#ifndef _INTFCTRL_H_
#define _INTFCTRL_H_

#include "comtypes.h"

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(push,1)   /* Packing compatible with WinAC */
#endif
#define OCTOPUS_BASE			0
#define SOFT_MODEM_BLOCK_BASE	100
#define NILE_BLOCK_BASE         200
#define NON_BLOCK		255
 
typedef enum
{
    BLOCK_COM_CTRL = OCTOPUS_BASE,
	BLOCK_MEM_MGR, 
	BLOCK_RT_MGR, 
	BLOCK_DEBUG_MGR, 
	BLOCK_STATUS_MGR, 
	BLOCK_CONFIG_MGR,
	BLOCK_DEVICE_MGR,
	BLOCK_SESSION_MGR,
	BLOCK_NVM_MGR,
	BLOCK_SCR_SRV,
	BLOCK_DMP_SRV,
	/* HSF blocks : */
    
    BLOCK_AT_DTE = SOFT_MODEM_BLOCK_BASE,
	BLOCK_HW_NONE , /* HSF hardware manager*/
	BLOCK_HW_BASIC2,
	BLOCK_HW_ICH,
	BLOCK_TONE_DET,
	BLOCK_TONE_GEN,
	BLOCK_ANS_DET,
	BLOCK_ANS_GEN,
	BLOCK_DTMF_DET,
	BLOCK_DTMF_GEN,
	BLOCK_CR_DET,
	BLOCK_CR_GEN,
	BLOCK_V23,
	BLOCK_V8,
	BLOCK_V21,
	BLOCK_V34,
	BLOCK_V90,
	BLOCK_V32,
	BLOCK_V32BIS,
	BLOCK_V22,
	BLOCK_V22BIS,
	BLOCK_BELL103,
	BLOCK_BELL212,

    /* Nile blocks */
    BLOCK_NILE_HW = NILE_BLOCK_BASE,
    BLOCK_DSL_DATAPUMP,

    BLOCK_NONE = NON_BLOCK
 
} BLOCK_TYPE;
 
typedef enum 
{
    HSF_ONLINE_COM_CNTRL,
    SDSL_BASIC_OFFLINE_COM_CNTRL
} COM_CNTRL_BLOCK_ID;
typedef enum 
{
    ATUR_BLOCK_ID,
    ATUC_BLOCK_ID,
    HSTUR_BLOCK_ID,
    HSTUC_BLOCK_ID
} DATAPUMP_BLOCK_ID;

typedef enum 
{
    NILEHW_RT_BLOCK_ID,  /* Real Time hw mgr               */
    NILEHW_B2B_BLOCK_ID, /* Back to Back hw mgr            */
    NILEHW_SR_BLOCK_ID   /* Session Reconstaruction hw mgr */
} NILE_HW_BLOCK_ID;
typedef PVOID(*GET_ENTRY_POINT_FUNC)(BLOCK_TYPE, UINT32);

typedef  PVOID (__stdcall *FUNC_CREATE_INTERFACE)(	BLOCK_TYPE		,
													UINT32	);

typedef COM_STATUS (__stdcall *FUNC_DESTROY_INTERFACE)(PVOID			);

typedef struct INTF_CTRL_FUNC_TABLE_TAG
{
	FUNC_CREATE_INTERFACE	CreateInterface;
	FUNC_DESTROY_INTERFACE	DestroyInterface;
}INTF_CTRL_FUNC_TABLE_T, *PINTF_CTRL_FUNC_TABLE_T;

typedef struct INSTANCE_ACCESS_INFO_TAG
{
	PVOID		InterfaceFunctionTable;
	HANDLE		hInstance;
}INSTANCE_ACCESS_INFO_T, *PINSTANCE_ACCESS_INFO_T;

typedef struct SYSTEM_INSTANCES_TAG
{
	INTF_CTRL_FUNC_TABLE_T	*pIntrfceCntrlFuncTable;
	INSTANCE_ACCESS_INFO_T	MemMgrInstanceInfo;
	INSTANCE_ACCESS_INFO_T	RTMgrInstanceInfo;
	INSTANCE_ACCESS_INFO_T	DbgMgrInstanceInfo;
	INSTANCE_ACCESS_INFO_T	StatusMgrInstanceInfo;
	INSTANCE_ACCESS_INFO_T	ConfigMgrInstanceInfo;
	INSTANCE_ACCESS_INFO_T	DevMgrInstanceInfo;
    INSTANCE_ACCESS_INFO_T  SessionMgrInstanceInfo;
    INSTANCE_ACCESS_INFO_T  AtDteInstanceInfo;
    INSTANCE_ACCESS_INFO_T  ComCtrlInstanceInfo;
}SYSTEM_INSTANCES_T, * PSYSTEM_INSTANCES_T;

PVOID GetInterfaceControllerFuncTable(	void );

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(pop)   /* Packing compatible with our VXDs */
#endif

#endif
