#ifndef _DMP_DEFS_H_
#define _DMP_DEFS_H_

#define MAX_LIST_SIZE		(32 * 0x100000) // 32 Mega
#define DMP_PAGE_SIZE		(4096)
#define SEGMENT_SIZE		(2*DMP_PAGE_SIZE)
#define MAX_NAME_LEN					100
#define DMP_ERR_LEN						100
#define START_MAGIC						0x11
#define END_MAGIC						0x22
#define MAX_SEGMENTS					100

#define MAX_CLIENTS						20
#define MAX_CLIENT_NAME					100


#ifndef NT_DRIVER
#define DMP_SET_ENTRY_POINT_CALLBACK	(DWORD)(BEGIN_RESERVED_PRIVATE_SYSTEM_CONTROL+1)
#define DMP_DELETE_ENTRY_POINT_CALLBACK	(DWORD)(BEGIN_RESERVED_PRIVATE_SYSTEM_CONTROL+2)
#define DMP_SET_IDLE_STATE              (DWORD)(BEGIN_RESERVED_PRIVATE_SYSTEM_CONTROL+3)
#endif

#ifndef NT_DRIVER
#include "winioctl.h"
#endif
#define DMP_GET_SEGMENT					CTL_CODE(FILE_DEVICE_UNKNOWN,		0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DMP_CONFIGURE_CLIENTS			CTL_CODE(FILE_DEVICE_UNKNOWN,		0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	DMP_GET_FUNCTION				CTL_CODE(FILE_DEVICE_UNKNOWN,		0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	DMP_GET_NUMBER_OF_CLIENTS		CTL_CODE(FILE_DEVICE_UNKNOWN,		0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DMP_DELETE_FUNCTION				CTL_CODE(FILE_DEVICE_UNKNOWN,		0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DMP_GET_NUM_INSTANCES			CTL_CODE(FILE_DEVICE_UNKNOWN,		0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DMP_GET_WINDOW_HANDLE			CTL_CODE(FILE_DEVICE_UNKNOWN,		0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DMP_GET_MSG_QUEUE			    CTL_CODE(FILE_DEVICE_UNKNOWN,		0x807, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DMP_SET_Q_SIZE_IN_K			    CTL_CODE(FILE_DEVICE_UNKNOWN,		0x808, METHOD_BUFFERED, FILE_ANY_ACCESS)


#define DMP_WAKE_MESSAGE			(0x0400+10)

#define MIN(a, b) (a)<(b) ? (a) : (b)

typedef enum {
	DMP_CREATE_FILE,
	DMP_WRITE_TO_FILE,
	DMP_SEEK_FILE,
	DMP_CLOSE_FILE,
} DMP_SERVER_CODE;

typedef (*PFN_SERVER)( PCHAR, DMP_SERVER_CODE, PCHAR, PBYTE, DWORD );

typedef struct {
	CHAR				ClientName[MAX_NAME_LEN];
	DMP_SERVER_CODE		Code;
	CHAR				FileName[MAX_NAME_LEN];
	BYTE				*pData;//[SEGMENT_SIZE];
	DWORD				nData;
    DWORD              hData;
    DWORD              PhysAddr;
} DMP_ACTION_INFO, *PDMP_ACTION_INFO;


#endif