/* oct_globals.h */

#include "memmgr_ex.h"
#include "statmgr_ex.h"
#include "rtmgr_ex.h"

#if (OS_TYPE != OS_LINUX) /* temporary until Linux supports scr prints */
#include "dbgmgr_ex.h"
#endif

#ifdef __cplusplus
extern "C"
{
#endif

extern PVOID			gpIDbgMgr;
extern HANDLE			ghDbgMgrInstance;

#if (OS_TYPE != OS_LINUX) /* temporary until Linux supports scr prints */
SCR_EXTERN_DEBUG_INSTANCE(hScrGlobalTemporary)
#endif

/** the global Memmory manager parameters. **/
extern PI_MEM_MGR_T		gpMemMgrIf;
extern HANDLE			ghMemMgrInstance;
extern HANDLE			ghMemMgrClient;

extern PI_STAT_MGR_T		gpStatMgrIf;
extern HANDLE				ghStatMgrInstance;
extern HANDLE				ghStatMgrClient;

extern PI_RT_MGR_T		    gpRTMgrIf;
extern HANDLE				ghRTMgrInstance;
extern HANDLE				ghRTMgrClient;

extern ASYNC_CALL_CONFIG_T AsyncCallInfo;

void SetDebugMgrGlobals(IN	PVOID	pIDbgMgr, 
						IN	HANDLE	hDbgMgrInstance);

void SetMemMgrGlobals(IN	PI_MEM_MGR_T	pMemMgrIf, 
					  IN	HANDLE			hMemMgrInstance,
					  IN	HANDLE			hMemMgrClient);

void SetStatMgrGlobals(IN	PI_STAT_MGR_T	pStatMgrIf, 
					  IN	HANDLE			hStatMgrInstance,
					  IN	HANDLE			hStatMgrClient);

void SetRTMgrGlobals( IN	PI_RT_MGR_T	    pRTMgrIf, 
					  IN	HANDLE			hRTMgrInstance,
					  IN	HANDLE			hRTMgrClient);

#ifdef __cplusplus
}
#endif
