
#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(push,1)   // Packing compatible with WinAC
#endif


/* interface for DUMP files */
GLOBAL	PVOID	DmpSrvGetInterface(void);

typedef enum 
{
    DMPSRV_CONFIG_FILE_PATH, /* pConfig = char* */
    DMP_CONFIG_FILTER_NAME,  /* pConfig = char* */
}DMPSRV_CONFIG_CODES_T;
typedef struct
{
    BOOL   (*SetIdleState)(int IdleState); /* not client specific */
    HANDLE (*CreateClient)();
    BOOL   (*OpenClient)(HANDLE hClient);
    BOOL   (*ConfigureClient)(HANDLE hClient, DMPSRV_CONFIG_CODES_T ConfigCode, PVOID pConfig);
    VOID   (*CloseClient)(HANDLE hClient);
    VOID   (*DestroyClient)(HANDLE hClient);
    int    (*WriteClient)(HANDLE hClient, BYTE *pBuf, int BufLen);
}I_DMP_SERVER;


/* end of interface for DUMP files */


/* interface for SCR files */

GLOBAL	PVOID	ScrSrvGetInterface(void);
typedef VOID (*PSET_CLIENT_INFO_CALLBACK)(HANDLE, PVOID);


	/********************************************************************************
	
	Function Name: ScrSrvGetInterface.

	Function Description:	The function returns a pointer to the Scr Server
							Export function table.
	Arguments: None.
	
	Return Value: A pointer to the Scr Srv interface functions structure.

	********************************************************************************/
GLOBAL	PVOID	ScrSrvGetInterface(void);

typedef struct I_SCR_SRV_TAG{
	VOID	(*SetClientInfo)(PSET_CLIENT_INFO_CALLBACK pClientCallBack, HANDLE hClient);
}I_SCR_SRV, *PI_SCR_SRV;

/* end of interface for SCR files */

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(pop)   // Packing compatible with our VXDs
#endif
