/*************************************************************************

File Name: OsFile.h

File Description: This file implements all the File utilities.

Function list:

GLOBAL:

STATIC:


************************************************************************/

#ifndef __OS_FILE_EX_H__
#define __OS_FILE_EX_H__

#ifdef __cplusplus
extern "C"
{
#endif

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(push,1)   // Packing compatible with WinAC
#endif

#define    FILE_MODE_READ   0x00000001
#define    FILE_MODE_WRITE  0x00000002
#define    FILE_MODE_BINARY 0x00000004
#define    FILE_MODE_TEXT   0x00000008
    

/********************************************************************************

Function Name: OsFileOpen.

Function Description:Return. 

Arguments: Filename - Filename.
		   Mode - FILE_MODE_READ/FILE_MODE_WRITE/FILE_MODE_BINARY

Return Value: A handle to an opened file

********************************************************************************/
HANDLE	OsFileOpen(IN char *Filename, DWORD Mode);

/********************************************************************************

Function Name: OsFileClose.

Function Description: Closes a file. 

Arguments: hFile - handle to a file.

Return Value: None

********************************************************************************/
VOID	OsFileClose(HANDLE hFile);

/********************************************************************************

Function Name: OsFileWrite.

Function Description:Writes a buffer . 

Arguments: 
    hFile - handle to a file.
    pBuffer - Pointer to data to be written
    Size - Item size in bytes
    count - Maximum number of items to be written



Return Value: returns the number of full items actually written

********************************************************************************/
int	OsFileWrite(
                HANDLE hFile, 
                IN  VOID *pBuffer, 
                IN  int Size, 
                IN  int count);
/********************************************************************************

Function Name: OsFileRead.

Function Description:Writes a buffer . 

Arguments: 
    hFile - handle to a file.
    pBuffer - Pointer to data to be read
    Size - Item size in bytes
    count - Maximum number of items to be read



Return Value: returns the number of full items actually read

********************************************************************************/
int	OsFileRead(
               IN   HANDLE hFile, 
               OUT  VOID *pBuffer, 
               IN   int Size, 
               IN   int count);

#if ( USE_PRAGMA_PACK == 1 )
#pragma pack(pop)   // Packing compatible with our VXDs
#endif

#ifdef __cplusplus
}
#endif

#endif /* __OS_STRING_EX_H__ */
