/*----------------------------------------------------------------------------
 *
 * The information contained in this file is confidential and 
 * proprietary to Conexant Systems Inc.
 * No part of this file may be reproduced or distributed, in any form
 * or by any means for any purpose, without the express written
 * permission of Conexant Systems Inc.
 *
 * Copyright (C) 1996-2001 Conexant Systems Inc. 
 * All rights reserved.
 *
 *----------------------------------------------------------------------------
 *
 * File: scrcommon.h
 *
 *----------------------------------------------------------------------------
 */
 
#ifndef __SCRCOMMON_H__
#define __SCRCOMMON_H__
 
 
#ifndef ENCRYPTED
#define ENCRYPTED
#endif
#ifndef AMCHAL
#include "ossysenv.h"
#endif
 
 
#define MAX_MESSAGE_LEN				400
#define MAX_MESSAGES				1600
#define MAX_APP_NAME				200
#define MAX_TOTAL_MESSAGE_LEN		(MAX_MESSAGE_LEN+MAX_APP_NAME+3)
#define MAX_VAR_NAME				100
#define MAX_FORMAT					100

typedef enum PRIORITY_DESCRIPTOR
{
	Q_RECORD_PRIORITY_NORMAL = 0,
		Q_RECORD_PRIORITY_MED,
		Q_RECORD_PRIORITY_HIGH,
		Q_RECORD_PRIORITY_DUMP,
}PRIORITY_DESCRIPTOR;

typedef VOID (*PCALLBACK)(PVOID);
typedef VOID (_fastcall *PDBG_PRINT_FUNC)(PCHAR, PRIORITY_DESCRIPTOR);

#ifdef __cplusplus
#if ((OS_ONE_OF(OS_WIN_NT4 | OS_WIN_WDM)) && (UK_MODE == UK_KERNEL))
#define SCRSRV_DEVICE_NAME L"DeviceScrSrv"
#define SCRSRV_DEVICE L"\\Device\\DeviceScrSrv0"
#define DEVICE_CLASS_NAME DbgSrvNTDevice   //DbgsrWDMDevice
#endif

//#if (OS_TYPE == OS_WIN_NT4) && (UK_MODE == UK_USER)
#if (OS_TYPE != OS_LINUX)
#ifndef CTL_CODE
#include <winioctl.h>
#endif
#endif /** OS_LINUX **/

#if defined ENCRYPTED
	#define DRIVER_NAME	    "MDMONSRV"
	#define DDB_DRIVER_NAME "MDMONSRV"
	#define APP_NAME		"ModeMOn"
#else
	#define DRIVER_NAME		"DBGSRV"
	#define DDB_DRIVER_NAME "DBGSRV  "
	#define APP_NAME		"DbgApp"
#endif

#define DBG_GET_MSG_QUEUE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_GET_EVENT_HANDLE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_REGISTER_APP CTL_CODE(FILE_DEVICE_UNKNOWN, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_CLOSE_CONNECTION CTL_CODE(FILE_DEVICE_UNKNOWN, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_UNMAP_QUEUE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_GET_EX_MESSAGE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_GET_WINDOW_HANDLE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_REGISTER_VXD CTL_CODE(FILE_DEVICE_UNKNOWN, 0x807, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_SET_ID CTL_CODE(FILE_DEVICE_UNKNOWN, 0x808, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_GET_NUM_INSTANCES CTL_CODE(FILE_DEVICE_UNKNOWN, 0x809, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_GET_VERSION CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80A, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IO_CHECK_FOR_OTHER_DEVICES CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80B, METHOD_BUFFERED, FILE_ANY_ACCESS)
//#define DBG_APP_IS_CLOSING		   CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80C, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define DBG_APP_OPENED CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80D, METHOD_BUFFERED, FILE_ANY_ACCESS)
#ifndef SCR_SET_ENTRY_POINT_CALLBACK
#define SCR_SET_ENTRY_POINT_CALLBACK	CTL_CODE(FILE_DEVICE_UNKNOWN, 0x80E, METHOD_BUFFERED, FILE_ANY_ACCESS)
#endif

 
 
 
#if ((OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL)) //Keep compatibility
 
#define OLD_DBG_VERSION					10
#define OLD_DBG_GET_MSG_QUEUE			40000
#define OLD_DBG_GET_CMD_QUEUE			40001
#define OLD_DBG_REGISTER_APP			40002
#define OLD_DBG_CLOSE_CONNECTION		40003
#define OLD_DBG_GET_EX_MESSAGE			40004
#define OLD_DBG_GET_WINDOW_HANDLE		40005
#define OLD_DBG_REGISTER_VXD			40006
#define OLD_DBG_SET_ID					40007
#define OLD_IO_CHECK_FOR_OTHER_DEVICES  40008
#define OLD_DBG_GET_VERSION             40009
#define OLD_DBG_GET_EVENT_HANDLE		40010
#endif
 
#define ENC_FILE_STRING             "HSF debug file"
#define MAX_MESSAGE_LEN				400
#define MAX_MESSAGES				1600
#define MAX_MESSAGES_ALLOWED		1600 - 20
#define MAX_APP_NAME				200
#define MAX_TOTAL_MESSAGE_LEN		(MAX_MESSAGE_LEN+MAX_APP_NAME+3)
#define MAX_VAR_NAME				100
#define MAX_FORMAT					100
#define DBG_VERSION                 30
#define MAX_CLIENT_VXD				20


#define ESC_SEQ                     ('$' << 24 | '#' << 16 | '@' << 8 | '!') // "!@#$"
#define ESCAPE_SEQ                  ESC_SEQ
#define IS_ESCAPE_SEQ(Msg)          (ESC_SEQ == *(DWORD *)(Msg))
#define STR_ESC_SEQ	                "!@#$"
 
#ifndef PRODUCT_VERSION_NAME
#define PRODUCT_VERSION_NAME		"Tools Dev Version"
#endif
 
#ifndef TOOLS_VERSION
#define TOOLS_VERSION				PRODUCT_VERSION_NAME
#endif
 
#ifndef DBGAPP_VERSION
#define DBGAPP_VERSION				TOOLS_VERSION
#endif
 
 
// Private Messages
#define TIMER_PROC_ELAPSED			(0x0400+3)
#define DBG_WAKE_MESSAGE			(0x0400+4)
#define COMMANDS                    "Commands"
#define MESSAGES                    "Messages"

#define HOOK_START					40011
#define HOOK_STOP					40012

#define DBG_ADD_MESSAGE				40000
#define DBG_ADD_COMMAND				40001
#define DBG_UPDATE_USAGE			40005


#define MAX_ERR_MESSAGE_LEN 70
#define	DBG_WAKE_THRESHOLD	(MAX_MESSAGES/8)
 
typedef struct 
{
    char msg [MAX_MESSAGE_LEN];
    DWORD len;
	DWORD key;
    PRIORITY_DESCRIPTOR  priority;
} QUEUE_RECORD;

 
/////////////////////////////////////////////////////////////////////////////
///// CMshQueue                           ///////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
class CMsgQueue
{
private:
	QUEUE_RECORD m_Queue [MAX_MESSAGES];
	DWORD		 m_dwNextIn;
	DWORD		 m_dwNextOut;
	DWORD        m_dwNumOfRecords;
	DWORD        m_dwNestedInsertsCounter;
	DWORD		 m_dwLostRecords;

public:
	
	CMsgQueue () ;
	~CMsgQueue();
	void Init	  ();
	BOOL 	  Remove(QUEUE_RECORD * delRecord/*OUT PCHAR msg*/);  // is called by the application
	DWORD	  GetQueueUsage();  // is called by the application
	BOOL			Insert(QUEUE_RECORD * myRecord/*IN PCHAR msg*/);
    BOOL	  Insert(IN PCHAR Msg, DWORD msgLen, PRIORITY_DESCRIPTOR  priority = Q_RECORD_PRIORITY_NORMAL);
	BOOL	  InsertDbgNumOfLosses ();
	BOOL			Alloc();
	BOOL			DeAlloc();
	BOOL			GotToThreshold();
	void	  TimerCallback ()  {};

	
};
/////////////////////////////////////////////////////////////////////////////
typedef CMsgQueue CMSGQUEUE;
/////////////////////////////////////////////////////////////////////////////
typedef CMSGQUEUE* PCMSGQUEUE;

#endif /* __cplusplus */

#endif /* __SCRCOMMON_H__ */

