# makefile for device manager module under linux

include $(MAK_ENV)

OS_SPECIFIC_ODIR = $(OS_SPECIFIC_DIR)/obj
OS_SPECIFIC_MODULE = $(OS_SPECIFIC_ODIR)/mod_osspecific.o
ALL_MODULES += $(OS_SPECIFIC_MODULE)

ifneq ($(MAIN_MAKE),yes)

INCLUDES =	-I $(COMMON_DIR)/include		\
			-I $(OCTOPUS_DIR)/include		\
			-I $(OCTOPUS_DIR)/osspecific	

C_FLAGS =	$(INCLUDES)		\
			$(ALL_FLAGS)

all : ALLODIRS osspecific_module


# Rules for OS specificfiles:
#-----------------

OS_SPECIFIC_FILES  = $(OCTOPUS_DIR)/osspecific/modosspec.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/osmemory.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/osstring.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/ostime.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/osbacktrace.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/osnvm.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/linuxres.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/osspecific/missing_c.c
OS_SPECIFIC_FILES += $(OCTOPUS_DIR)/utilities/cdbgscr.c

OS_SPECIFIC_CPP_FILES = $(OCTOPUS_DIR)/osspecific/missing.cpp

ALL_ODIRS += $(OS_SPECIFIC_ODIR)

OS_SPECIFIC_OBJS = $(patsubst %.c,$(OS_SPECIFIC_ODIR)/%.o,$(notdir $(OS_SPECIFIC_FILES)))
OS_SPECIFIC_OBJS += $(patsubst %.cpp,$(OS_SPECIFIC_ODIR)/%.o,$(notdir $(OS_SPECIFIC_CPP_FILES)))

vpath %.c $(OS_SPECIFIC_DIR)/osspecific $(OCTOPUS_DIR)/utilities
vpath %.cpp $(OS_SPECIFIC_DIR)/osspecific

$(OS_SPECIFIC_ODIR)/%.o: %.c
	cc $(C_FLAGS) -c -o $@ $<
	@/bin/mv -f $(patsubst %.o,%$(GCC_TEMPS_EXT),$(notdir $@)) $(OS_SPECIFIC_ODIR)

$(OS_SPECIFIC_ODIR)/%.o: %.cpp
	$(GPP) $(C_FLAGS) -c -o $@ $<
	@/bin/mv -f $(patsubst %.o,%$(GPP_TEMPS_EXT),$(notdir $@)) $(OS_SPECIFIC_ODIR)

# End of device manager Cfiles:
#-----------------


ALL_LIBS =	$(OS_SPECIFIC_OBJS)

$(OS_SPECIFIC_MODULE): $(ALL_LIBS)
	$(LD) -o $@ $(LD_FLAGS) -r $^

osspecific_module: $(OS_SPECIFIC_MODULE)

# Output directories rule (must be after all ALL_ODIRS += statements:
ALLODIRS: $(ALL_ODIRS)

$(ALL_ODIRS):
	mkdir -p $@

endif # of if (MAIN_MAKE)

# DO NOT DELETE
