#
# octopus_export.mak - defines the rules to create a library named liboct.a,
#                      under `$(OUTDIR)/octc_objs'. liboct.a is needed to get
#                      oct_memorymgr, osmemory, osstrings and ostime support.
#                      include this file, and add $(OCTC_LIB) to the link line.
#

ifeq ($(OCT_OUTDIR),)
error "You must define OCT_OUTDIR to where the octopus lib must be compiled"
endif

# Rules for Cfiles (from octopus):
#---------------

OCTC_FILES  = $(OCTOPUS_DIR)/utilities/oct_globals.c

OCTCPP_FILES = $(OCTOPUS_DIR)/memorymgr/new_delete.cpp

OCTC_OBJS  = $(patsubst %.c,$(OCT_OUTDIR)/%.o,$(notdir $(OCTC_FILES)))
OCTC_OBJS += $(patsubst %.cpp,$(OCT_OUTDIR)/%.o,$(notdir $(OCTCPP_FILES)))

ALL_ODIRS += $(OCT_OUTDIR)
OCTC_LIB = $(OCT_OUTDIR)/liboct.a

vpath %.c $(OCTOPUS_DIR)/osspecific $(OCTOPUS_DIR)/utilities
vpath %.cpp $(OCTOPUS_DIR)/memorymgr

$(OCT_OUTDIR)/%.o: %.c
	$(GCC) $(C_FLAGS) -c -o $@ $<
	@/bin/mv -f $(patsubst %.o,%$(GCC_TEMPS_EXT),$(notdir $@)) $(OCT_OUTDIR)

$(OCT_OUTDIR)/%.o: %.cpp
	$(GPP) $(C_FLAGS) -c -o $@ $<
	@/bin/mv -f $(patsubst %.o,%$(GPP_TEMPS_EXT),$(notdir $@)) $(OCT_OUTDIR)

$(OCTC_LIB): $(OCTC_OBJS) 
	ar -r $(OCTC_LIB) $(OCTC_OBJS)

