#ifndef _CD_SCR_H_
#define _CD_SCR_H_

#define DBG_GET_MESSAGE					40000
#define DBG_GET_EVENT_HANDLE		40001
#define DBG_REGISTER_APP				40002
#define DBG_CLOSE_CONNECTION		40003
#define DBG_ADD_MESSAGE					40004
#define DBG_GET_EX_MESSAGE			40005
#define DBG_GET_WINDOW_HANDLE		40006
#define DBG_REGISTER_VXD				40007
#define DBG_SET_ID							40008

#define MAX_MESSAGE_LEN				100
#define MAX_APP_NAME					200
#define MAX_TOTAL_MESSAGE_LEN		(MAX_MESSAGE_LEN+MAX_APP_NAME+3)
#define MAX_VAR_NAME					100
#define MAX_FORMAT						100

//#define ESC_SEQ	"!@#$"


#define SCR_SET_ENTRY_POINT_CALLBACK	(DWORD)(BEGIN_RESERVED_PRIVATE_SYSTEM_CONTROL+1)

typedef VOID (*PCALLBACK)(PVOID);
typedef VOID  (* PFUNC)(PCHAR);

typedef enum {
		FMT_CHAR,
		FMT_INT,
		FMT_INTX,
		FMT_FLOAT,
		FMT_FLOATG,
		FMT_FLOATE,
		FMT_STRING,
		FMT_COMPLEX
} FORMATTYPE;


//#define sprintf _Sprintf

typedef ULONG		PDDB;

typedef struct {
	BOOL						IsRegistered;
	CHAR						Name[MAX_APP_NAME + 1];
} SCR_CLIENT, *PSCR_CLIENT;

typedef struct {
	BOOL					IsRegistered;
	CHAR					Name[MAX_VAR_NAME + 1];
	CHAR					Format[MAX_FORMAT + 1];
	FORMATTYPE		FormatType;
} WATCH_CLIENT, *PWATCH_CLIENT;

static PFUNC						pPrintFunc = NULL;
static PDDB							pServerDDB = NULL;
static BOOL							ScrServerOn = FALSE;

PSCR_CLIENT _cdecl 		CreateScr();
void				_cdecl		CloseScr( PSCR_CLIENT pScr );
BOOL				_cdecl		ScrRegister( PSCR_CLIENT pScr, PCHAR Path );
BOOL				_cdecl		ScrUnregister( PSCR_CLIENT pScr );
DWORD				_cdecl		ScrPrint( PSCR_CLIENT pScr, PCHAR FmtString, ... );

PWATCH_CLIENT _cdecl 	CreateWatch( PCHAR Name, PCHAR Format );
void				_cdecl		CloseWatch( PSCR_CLIENT pWatch );
void				_cdecl		WatchUpdate( PWATCH_CLIENT pWatch, PVOID pVal);


BOOL				_cdecl		ConnectToScrServer();
VOID				_cdecl		GetScrServerEntryPoint( PVOID pParam );
VOID				_cdecl		GetMyVxdName( PCHAR Name );
void				_cdecl		SimpleFormat(PWATCH_CLIENT pWatch,PCHAR Dst, PCHAR FmtString, PVOID pStack);

#endif