/*
 * cdbgscr.c - c implementation of SCR printing.
 */

#include "ossysenv.h"
#include "osmemory_ex.h"
#include "cdbgscr_ex.h"
#include "scrcommon.h"

#if ( (OS_TYPE == OS_LINUX) && (UK_MODE == UK_KERNEL) )
#include "linux_dbgscr.h"
#endif


static PDBG_PRINT_FUNC ScrPrintFunc = NULL;


static VOID setScrPrintFunc( PVOID func )
{
	ScrPrintFunc = func;

}  /* setScrPrintFunc */


DWORD C_ScrFormat( IN PCHAR FmtString, ... )
{
	char str[256];
	va_list ap;
	int nc;

	if ( NULL == ScrPrintFunc )
	{
		LinuxScrSetEntryPointCallback( (UINT32) setScrPrintFunc );
		if ( NULL == ScrPrintFunc )
		{
			return 0;
		}
	}

	va_start( ap, FmtString );
	nc = vsprintf( str, FmtString, ap );
	va_end( ap );

	ScrPrintFunc( str, Q_RECORD_PRIORITY_NORMAL );

	return nc;

}  /* C_ScrFormat */
