#define BLOCK_NUM 25
#define DEVICE_NUM 25

#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )

#define MAX_DEVICE_NAME 20
typedef enum 
{
	MEM_MGR_DEV_INDEX,
	RT_MGR_DEV_INDEX,
	STATUS_MGR_DEV_INDEX,
	CONFIG_MGR_DEV_INDEX,
	DEBUG_MGR_DEV_INDEX,
	NVM_MGR_DEV_INDEX,
	SCR_SRV_DEV_INDEX,
	HW_DEV_INDEX,
} DEV_INDEXES;
typedef struct BLOCK_TO_DEVICE_MAP_TAG
{
	BLOCK_TYPE	BlockType;
	UINT32		BlockID;
	int			DeviceIndex; /* Intex in Device Info Table*/
}BLOCK_TO_DEVICE_MAP_T, *PBLOCK_TO_DEVICE_MAP_T;

typedef struct DEVICE_INFO_TAG
{
	char	DeviceName[MAX_DEVICE_NAME];
	int		nClients;
} DEVICE_INFO_T, *PDEVICE_INFO_T;


#endif // OS_VXD


#if ( ((OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_USER)) || \
      ( OS_TYPE == OS_LINUX ) )
typedef PVOID	(*FUNC_GET_INTERFACE)();

typedef struct BLOCK_TO_INTERFACE_MAP_TAG
{
	BLOCK_TYPE			BlockType;
	UINT32				BlockID;
	FUNC_GET_INTERFACE	GetInterface;
}BLOCK_TO_INTERFACE_MAP_T, *PBLOCK_TO_INTERFACE_MAP_T;
#endif

