/*
 * osbacktrace.c - implement the backtrace routine for different OS/Compilers.
 */

#include "osbacktrace_ex.h"
#include "cdbgscr_ex.h"
#include "scrcommon.h"
#include "osstring_ex.h"


int OSBackTrace( DWORD *bt_buff, int max_depth, IN PCHAR NodeName )
{
	int depth = 0, i = 0, buff_idx;
	char buff[MAX_APP_NAME+78];
	register DWORD *_ebp, ret_addr;

	if ( NULL != NodeName )
	{
		OsStrnCpy( buff, NodeName, MAX_APP_NAME );
	}
	else {
		OsStrCpy( buff, "ALL/BackTrace " );
	}
	buff_idx = OsStrLen( buff );

	sprintf( &buff[buff_idx], "Functions back-trace:" );
	C_ScrFormat( buff );

	asm( "mov %%ebp, %0\n" : "=g" (_ebp) );

	while ( ( (max_depth <= 0) || (depth < max_depth) ) &&
			((((DWORD) _ebp) & 0xf0000000) == 0xc0000000) )
	{
		ret_addr = _ebp[1];
		if ( (ret_addr & 0xf0000000) != 0xc0000000 )
			break;
		if ( NULL != bt_buff )
		{
			bt_buff[depth] = ret_addr;
		}
		else
		{
			sprintf( &buff[buff_idx+i*11], " 0x%08lx", (UINT32) ret_addr );
			if ( ++i == 7 )
			{
				buff[buff_idx+i*11] = '\0';
				C_ScrFormat( buff );
				i = 0;
			}
		}
		depth++;
		_ebp = (DWORD *) _ebp[0];
	}

	if ( (NULL == bt_buff) && (0 != i) )
	{
		buff[buff_idx+i*11] = '\0';
		C_ScrFormat( buff );
	}

	return depth;

}  /* OSBackTrace */
