#include "newdmpdefs.h"
#define MAX_DUMP_FILTER_NAME    20
#define MAX_DUMP_PATH_SIZE			100


#if ( ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) ) || ( (OS_TYPE == OS_WIN_WDM) && (UK_MODE == UK_KERNEL) ) )
typedef struct
{
    char FilterName[MAX_DUMP_FILTER_NAME];
    char Path[MAX_DUMP_PATH_SIZE];

    PFN_SERVER  pServerFunc;
    char        *pSegment;
	UINT32		PhysAddr; 
    UINT32      hData;
    UINT32      SegmentCount;
}DMPSRV_CLIENT_INFO_T;

#endif

#if ( (OS_TYPE == OS_WIN_WDM) && (UK_MODE == UK_KERNEL) ) 

	NTSTATUS DeviceIoControl(
			ULONG IoControlCode,
			PVOID InputBuffer,
			ULONG InputBufferSize,
			PVOID OutputBuffer,
			ULONG OutputBufferLength,
			BOOLEAN Internal,
			ULONG* pInformation
			);
	NTSTATUS GetConstructorStatus(void);
	VOID construct(IN PCWSTR name, IN ACCESS_MASK access);
	KEvent(EVENT_TYPE type, BOOLEAN signaled);

	NTSTATUS ConstructorStatus;		
	PDEVICE_OBJECT pDeviceObject;
	PFILE_OBJECT pFileObject;		
	BOOLEAN CreatedByName;
	PVOID pObject;

#endif


#if ((OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_USER)) 
typedef struct
{
    char FilterName[MAX_DUMP_FILTER_NAME];
    char Path[MAX_DUMP_PATH_SIZE];
    FILE *pFile;
}DMPSRV_CLIENT_INFO_T;
#define APP_NAME "ModeMOn"
#endif

BOOL    DmpServer_SetIdleState(int IdleState);
HANDLE DmpServer_CreateClient();
BOOL   DmpServer_ConfigureClient(
                                 HANDLE                 hClient, 
                                 DMPSRV_CONFIG_CODES_T  ConfigCode, 
                                 PVOID                  pConfig);
BOOL    DmpServer_OpenClient(    HANDLE                 hClient);
VOID    DmpServer_CloseClient(   HANDLE                 hClient);
VOID    DmpServer_DestroyClient( HANDLE                 hClient);
int     DmpServer_WriteClient(   HANDLE                 hClient, 
                                 BYTE *                 pBuffer, 
                                 int                    nData);
VOID	GetDbgServerEntryPoint(PVOID pParam);

#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )
BOOL FindServer(DMPSRV_CLIENT_INFO_T   *pClientInfo, PCHAR ClientName);
BOOL DisconnectServer(DMPSRV_CLIENT_INFO_T   *pClientInfo);
BOOL DumpToServer(DMPSRV_CLIENT_INFO_T   *pClientInfo);
#endif



