/*osTimeI.h*/
/* Internal osTimeOut types :*/
#if ( OS_TYPE == OS_LINUX )
#include <linux/timer.h>
#include <linux/tqueue.h>
#include <linux/time.h>
#include <asm/semaphore.h>
#include <linux/malloc.h>
#include <asm/system.h>
#endif 
typedef enum { INTERUPT_STATUS_DISABLE, INTERUPT_STATUS_RESTORE } INTERUPT_STATUS_STATUS;
typedef struct TIME_OUT_INSTANCE_TYPE
{
#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )
	TIMEOUT_THUNK	TimeOuthunk;
	TIMEOUTHANDLE	TimeOutHandle;
	THREADHANDLE	hThread;
	SEMHANDLE		hSemaphore;
#endif
#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_USER) )
	UINT			TimeOutHandle;
	HANDLE			hThread;
	HANDLE			hSemaphore;
#endif
#if ( OS_TYPE == OS_LINUX )
	struct tq_struct	TaskQueue;
	struct wait_queue	*WaitQueue;
	struct timer_list	Timer;
	BOOL                active;
	int					Count;
#endif
	UINT32			mSec;
	BOOL			bLocked;

	PFREE_FUNC		pFuncFree;
	PVOID			pRefData;

	PCBFUNC			pTimeOutCallBack;

}TIME_OUT_INSTANCE_T, *PTIME_OUT_INSTANCE_T;
#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )
typedef struct STACK_CHANGE_INFO_TAG
{
	PCBFUNC		pFunc;
	UINT32		lParam;
}STACK_CHANGE_INFO_T, *PSTACK_CHANGE_INFO_T;
#endif
 
#define NO_REQUESTS			-1
#define HANDLED_REQUEST		0
#define UNHANDLED_REQUEST	1
 
typedef struct {
	BYTE Save87State[120];
	DWORD SavedCR0;
} REGSTAT, *PREGSTATE;
 
#if ( OS_TYPE != OS_LINUX )
VOID InterruptEnable( INTERUPT_STATUS_STATUS Status );
#endif
 
/* private osTimeOut functions :*/
#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_KERNEL) )
StdCall( STATIC VOID ,  TimeOutHandler(VMHANDLE hVM, PCLIENT_STRUCT pcrs, PVOID RefData, UINT32 Extra) );
STATIC VOID TimerThreadFunction(DWORD hTimeOut);
CDecl( STATIC VOID, FuncOnNewStack(UINT32	lParam) );
#endif
#if ( OS_TYPE == OS_LINUX )
STATIC VOID TimeOutHandler(unsigned long Data);
STATIC VOID TimerThreadFunction(PVOID pData);

STATIC VOID  ClearTS(void);

#endif
#if ( (OS_TYPE == OS_WIN_9X) && (UK_MODE == UK_USER) )
STATIC void CALLBACK   TimeOutHandler(	
									UINT	uID, 
									UINT	uMsg, 
									UINT32	dwUser,
									UINT32	dw1,     
									UINT32	dw2      );
STATIC UINT32 WINAPI TimerThreadFunction(  LPVOID lpParameter   );

#endif
