# Top of tree. This is where this file is. DO NOT change to `.'! Will not work

export MAK_ENV := $(ROOT)/sw_modem/linux/linux_envvar.mak
include $(MAK_ENV)

MAKE = make $(MJ)

MAIN_MAKE = yes
include $(OS_SPECIFIC_DIR)/$(OS_SPECIFIC_MAK)
include $(OCTOPUS_DIR)/$(OCTOPUS_MAK)
include $(SES_CTRL_DIR)/$(SES_CTRL_MAK)
include $(DEVMGR_DIR)/$(DEVMGR_MAK)
include $(V90_DIR)/$(V90_MAK)
include $(V34_DIR)/$(V34_MAK)
include $(TONES_DIR)/$(TONES_MAK)
include $(FSKS_DIR)/$(FSKS_MAK)
include $(FALLBACKS_DIR)/$(FALLBACKS_MAK)
include $(DBGSCR_DIR)/$(DBGSCR_MAK)
include $(SOAR_DIR)/$(SOAR_MAK)
include $(BASIC2_DIR)/$(BASIC2_MAK)
include $(ICH_DIR)/$(ICH_MAK)
include $(PORT_DRV_DIR)/$(PORT_DRV_MAK)
include $(INF2BIN_DIR)/$(INF2BIN_MAK)

all : OsSpecific Octopus Sessionctrl Devmgr V90 V34 Tones Fsks Fallback Dbgscr Basic2 Ich Soar Port_driver Inf2bin # Basic2 Port_driver Inf2bin

prepare :
	@chmod u+x `find . -iname fixfiles.csh`
	@echo Running `find . -iname fixfiles.csh`
	@`find . -iname fixfiles.csh`

OsSpecific:
	$(MAKE) -C $(OS_SPECIFIC_DIR) -f $(OS_SPECIFIC_MAK)
Octopus:
	$(MAKE) -C $(OCTOPUS_DIR) -f $(OCTOPUS_MAK)
Sessionctrl:
	$(MAKE) -C $(SES_CTRL_DIR) -f $(SES_CTRL_MAK)
Devmgr:
	$(MAKE) -C $(DEVMGR_DIR) -f $(DEVMGR_MAK)
V90:
	$(MAKE) -C $(V90_DIR) -f $(V90_MAK)
V34:
	$(MAKE) -C $(V34_DIR) -f $(V34_MAK)
Tones:
	$(MAKE) -C $(TONES_DIR) -f $(TONES_MAK)
Fsks:
	$(MAKE) -C $(FSKS_DIR) -f $(FSKS_MAK)
Fallback:
	$(MAKE) -C $(FALLBACKS_DIR) -f $(FALLBACKS_MAK)
Dbgscr:
	$(MAKE) -C $(DBGSCR_DIR) -f $(DBGSCR_MAK)
Basic2:
	$(MAKE) -C $(BASIC2_DIR) -f $(BASIC2_MAK)
Ich:
	$(MAKE) -C $(ICH_DIR) -f $(ICH_MAK)
Soar:
	$(MAKE) -C $(SOAR_DIR) -f $(SOAR_MAK)
Port_driver:
	$(MAKE) -C $(PORT_DRV_DIR) -f $(PORT_DRV_MAK)
Inf2bin:
	$(MAKE) -C $(INF2BIN_DIR) -f $(INF2BIN_MAK)

copy_modules:
	/bin/mkdir -p $(MODULES_DIR)
	/bin/rm -rf $(MODULES_DIR)/*
	/bin/cp -p $(ALL_MODULES) $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/ins_all $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/ins_all_os $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/ins_all_dbg $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/rm_all $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/hsf_linstall.pl $(MODULES_DIR)
	/bin/cp -p $(INF2BIN) $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/*.inf $(MODULES_DIR)
	/bin/cp -p $(ROOT)/linux_install/README $(MODULES_DIR)
	/bin/mkdir -p $(MODULES_DIR)/octopus
	/bin/cp -pr $(ROOT)/octopus/include $(MODULES_DIR)/octopus
	/bin/cp -pr $(ROOT)/octopus/osspecific $(MODULES_DIR)/octopus
	/bin/cp -pr $(ROOT)/octopus/linux $(MODULES_DIR)/octopus
	/bin/cp -pr $(ROOT)/port_driver $(MODULES_DIR)
	/bin/cp -pr $(ROOT)/common $(MODULES_DIR)
	/bin/mkdir -p $(MODULES_DIR)/sw_modem
	/bin/cp -pr $(ROOT)/sw_modem/linux $(MODULES_DIR)/sw_modem
	/bin/cp -pr $(ROOT)/sw_modem/build $(MODULES_DIR)/sw_modem
	/bin/chmod -R 777 $(MODULES_DIR)

clean :
	/bin/rm -rf $(OS_SPECIFIC_ODIR) $(OCTOPUS_ODIR) $(SES_CTRL_ODIR) $(DEVMGR_ODIR) $(V90_ODIR) $(V34_ODIR) $(TONES_ODIR) $(FSKS_ODIR) $(FALLBACKS_ODIR) $(DBGSCR_ODIR) $(BASIC2_ODIR) $(ICH_ODIR) $(SOAR_ODIR) $(PORT_DRV_ODIR) $(INF2BIN_ODIR) $(MODULES_DIR) 
 
clean_osspecific:
	/bin/rm -rf $(OS_SPECIFIC_ODIR) $(PORT_DRV_ODIR)  $(DBGSCR_ODIR)
 
copy_osspecific:
	/bin/cp -p $(ALL_MODULES) $(ROOT)
