/*
 * ktime.h - header for implementation of some time functions for the module.
 */

#ifndef _KTIME_H_
#define _KTIME_H_


#include <linux/time.h>
/*  #include "sysenv.h" */

struct tm {
  int tm_sec;                   /* Seconds.     [0-60] (1 leap second) */
  int tm_min;                   /* Minutes.     [0-59]   */
  int tm_hour;                  /* Hours.       [0-23]   */
  int tm_mday;                  /* Day.         [1-31]   */
  int tm_mon;                   /* Month.       [0-11]   */
  int tm_year;                  /* Year - 1900.          */
  int tm_wday;                  /* Day of week. [0-6]    */
  int tm_yday;                  /* Days in year.[0-365]  */
  int tm_isdst;                 /* DST.         [-1/0/1] */

# ifdef __USE_BSD
  long int tm_gmtoff;           /* Seconds east of UTC.  */
  __const char *tm_zone;        /* Timezone abbreviation.*/
# else
  long int __tm_gmtoff;         /* Seconds east of UTC.  */
  __const char *__tm_zone;      /* Timezone abbreviation.*/
# endif
};

extern char* ktime_month_name[12];
extern char* ktime_month_sname[12];
void ktime_tv_sec_to_tm( struct tm *ptm, time_t time );


#endif
