# makefile for the dbgscr module under linux

include $(MAK_ENV)

DBGSCR_ODIR = $(DBGSCR_DIR)/obj
LIN_DSMODULE = $(DBGSCR_ODIR)/dbgscr_mod.o 
ALL_MODULES += $(LIN_DSMODULE)

ifneq ($(MAIN_MAKE),yes)

INCLUDES  = -I $(COMMON_DIR)/include		\
			-I $(OCTOPUS_DIR)/osspecific	\
			-I $(OCTOPUS_DIR)/include	\
			-I $(SW_MODEM_DIR)/dspmodls		\
			-I $(SW_MODEM_DIR)/include		\
			-I $(SW_MODEM_DIR)/linux

C_FLAGS =	$(INCLUDES)		\
			$(ALL_FLAGS)

all : ALLODIRS lin_dbgscr_mod


# Other LIBRARIES (mmx_code, clib & dspm):
#------------------------------------------

MLOUTDIR = $(DBGSCR_ODIR)
include linux/modulation_libs.mak


# Rules for dbgscr:
#-------------------

LIN_DS_ODIR = $(DBGSCR_ODIR)/lin_dbgscr
ALL_ODIRS += $(LIN_DS_ODIR)

vpath %.c $(SW_MODEM_DIR)/linux

$(LIN_DS_ODIR)/%.o: %.c
	$(GCC) $(C_FLAGS) -c -o $@ $<
	@/bin/mv -f $(patsubst %.o,%$(GCC_TEMPS_EXT),$(notdir $@)) $(LIN_DS_ODIR)


LIN_DSMODMAIN = $(LIN_DS_ODIR)/linux_dbgscr.o

LIN_DSMOD_OBJS  = $(LINUX_LIB)

$(LIN_DSMODULE): $(LIN_DSMODMAIN) $(LIN_DSMOD_OBJS)
	$(LD) -o $@ $(LD_FLAGS) -r $(LIN_DSMODMAIN) $(LIN_DSMOD_OBJS) 

lin_dbgscr_mod: $(LIN_DSMODULE) 

# Output directories rule (must be after all ALL_ODIRS += statements:
ALLODIRS: $(ALL_ODIRS)

$(ALL_ODIRS):
	mkdir -p $@

endif # of if (MAIN_MAKE)

# DO NOT DELETE
