# Environment variables for linux compilations - global defines.

WARNING_FLAGS =	-Wall					\
				-Wundef					\
				-Wno-comment			\
				-Wstrict-prototypes		\
				-Wno-unknown-pragmas	\
				-Wno-non-virtual-dtor

COMPILATION_FLAGS = -O2 			\
		    		-fno-rtti		\
					-save-temps		\
                    -march=pentium	\
					-DCPU=CPU_VER	\
		    		-fno-exceptions
#                   -malign-double	\ BAD! not compatible with kernel objects!
#					-fomit-frame-pointer	\
#					-fno-strength-reduce	\
#					-m386					\
#					-DCPU=386				\
#					-pipe					\

C_DEFINES = -DFRAME_WORK=FWK_LINUX_SOFTK56	\
			-imacros $(COMMON_DIR)/include/framewrk.h \
			-D__KERNEL__					\
			-DMODULE						\
			-DOVERRIDE_NEW					\
			-DPORTABILITY=0					\
			-DCONS_SCR=1					\
			-DCONS_APP=1					\
			-DV34_APPLY_TIME=0				\
			-DIMP_DLL=0						\
			-DMULTYDP						\
			-DMODEM_BINDUMP=0				\
			-DNDEBUG						\
			-DSCR							\
			-UDMP							\
			-DNOASSERTS						


C_ASM_FLAGS = -Wa,"-ahsl=$(@:%.o=%.lst)" 

LD_FLAGS = -Map=$(@:%.o=%.map) #-m elf_i386 -dynamic-linker

ALL_FLAGS = $(WARNING_FLAGS)		\
			$(COMPILATION_FLAGS)	\
			$(C_DEFINES)			\
			$(C_ASM_FLAGS)

GPP = /usr/bin/g++
GCC = /usr/bin/gcc
GPP_TEMPS_EXT = .{s,ii}
GCC_TEMPS_EXT = .{s,i}

ASM = $(SW_MODEM_DIR)/tools/unix/as-2.9.1
ASM_CVT = $(SW_MODEM_DIR)/mmx_code/cvt_asm.pl
ASM_INCLUDE = -I $(SW_MODEM_DIR)/tools/asm/incl614 
ASM_FLAGS = $(ASM_INCLUDE) -ahsl=$(@:%.o=%.lst) 

# Extract version number from headers.
VER = $(shell awk -F\" '/REL/ {print $$2}' /usr/include/linux/version.h)

COMMON_DIR = $(ROOT)/common

OCTOPUS_DIR = $(ROOT)/octopus
OCTOPUS_MAK = linux/linuxoctopus.mak

OS_SPECIFIC_DIR = $(ROOT)/octopus
OS_SPECIFIC_MAK = linux/linux_osspecific.mak

SES_CTRL_DIR = $(ROOT)/hsf4octopus/sessionctrl
SES_CTRL_MAK = linux/sessionctrl.mak

DEVMGR_DIR = $(ROOT)/hsf4octopus/devmgr
DEVMGR_MAK = linux/linuxdevmgr.mak

SW_MODEM_DIR = $(ROOT)/sw_modem

V90_DIR = $(SW_MODEM_DIR)
V90_MAK = v90/linux_v90.mak

V34_DIR = $(SW_MODEM_DIR)
V34_MAK = linux/v34batch.mak

TONES_DIR = $(SW_MODEM_DIR)
TONES_MAK = tones/linux_tones.mak

FSKS_DIR = $(SW_MODEM_DIR)
FSKS_MAK = fsks/linux_fsks.mak

FALLBACKS_DIR = $(SW_MODEM_DIR)
FALLBACKS_MAK = fallback/linux_fallback.mak

DBGSCR_DIR = $(SW_MODEM_DIR)
DBGSCR_MAK = linux/linux_dbgscr.mak

BASIC2_DIR = $(SW_MODEM_DIR)
BASIC2_MAK = rksample/linux_basic2.mak

ICH_DIR = $(SW_MODEM_DIR)
ICH_MAK = rksample/linux_ich.mak
 
SOAR_DIR = $(SW_MODEM_DIR)
SOAR_MAK = soar/linux_soar.mak

PORT_DRV_DIR = $(ROOT)/port_driver
PORT_DRV_MAK = makefile

INF2BIN_DIR = $(ROOT)/linux_install/inf2bin
INF2BIN_MAK = makefile

MODULES_DIR = $(ROOT)/linux_install/modules

# End of makefile.
