/*
 * missing.cpp - missing c++ functions implementations.
 */

#include "sysenv.h"
#include "missing.h"
#include "missing_c.h"


#ifndef OVERRIDE_NEW

void* operator new( unsigned int Size )
{
	printk(" NO MEM MGR:: new &&&&&&&&&&&&&&\n");
    void *temp = kernelmalloc(Size);

	if ( NULL != temp )
		memset( temp, 0 , Size );
	else
		printk( "operator new: kmalloc (%d) failed!!!\n", Size );
	return temp;
}

void* operator new[]( unsigned int Size )
{
	printk(" NO MEM MGR:: new[] &&&&&&&&&&&&&&\n");
    return kernelmalloc(Size);
}

void operator delete( void* pData )
{
	printk(" NO MEM MGR:: delete &&&&&&&&&&&&&&\n");
	if ( NULL != pData )
		kernelfree(pData);
}

void operator delete[]( void* pData )
{
	printk(" NO MEM MGR:: delete[] &&&&&&&&&&&&&&\n");
	if ( NULL != pData )
		kernelfree(pData);
}

#endif /** OVERRIDE_NEW **/


/* If not using octopus need to implement the following.
   This means that all files (per vxd / dll / module should be compiled with
   the same value of OCT_SW_MODEM. */
#if ( OCT_SW_MODEM == 0 )

/* Copy N bytes of SRC to DEST.  */
__ptr_t memcpy __P ((__ptr_t __restrict __dest,
					 __const __ptr_t __restrict __src, size_t __n))
{
    unsigned int i;
    char *d = ((char *) __dest), *s = ((char *) __src);

    for ( i = 0; i < __n; i++ )
    {
		d[i] = s[i];
    }

    return __dest;
}

/* Copy N bytes of SRC to DEST, guaranteeing
   correct behavior for overlapping strings.  */
__ptr_t memmove __P ((__ptr_t __dest, __const __ptr_t __src,
					  size_t __n))
{
    unsigned int i;
    char *d = ((char *) __dest), *s = ((char *) __src);

    if ( (d > s) && (s+__n > d) )
    {
		for ( i = __n-1; i >= 0 ; i-- )
		{
			d[i] = s[i];
		}
    }
    else {
		for ( i = 0; i < __n; i++ )
		{
			d[i] = s[i];
		}
    }

    return __dest;
}

/* Set N bytes of S to C.  */
__ptr_t memset __P ((__ptr_t __s, int __c, size_t __n))
{
    unsigned int i;
    char *s = ((char *) __s), sc = (char) __c;

    for ( i = 0; i < __n; i++ ) {
		s[i] = sc;
    }

    return __s;
}

/* Copy SRC to DEST.  */
char *strcpy __P ((char *__restrict __dest,
				   __const char *__restrict __src))
{
    char *d = ((char *) __dest), *s = ((char *) __src);

    do
    {
		*d++ = *s++;
    } while ( *s != '\0' );
	*d = '\0';

    return __dest;
}

/* Copy no more than N characters of SRC to DEST.  */
char *strncpy __P ((char *__restrict __dest,
					__const char *__restrict __src, size_t __n))
{
    unsigned int i = 0;
    char *d = ((char *) __dest), *s = ((char *) __src);

    do
    {
		*d++ = *s++;
		i++;
    } while ( (i < __n) && (*s != '\0') );

    return __dest;
}

/* Append SRC onto DEST.  */
char *strcat __P ((char *__restrict __dest,
				   __const char *__restrict __src))
{
    char *d = ((char *) __dest), *s = ((char *) __src);

    while ( *d != '\0' )
		d++;

    do
    {
		*d++ = *s++;
    } while ( *s != '\0' );
	*d = '\0';

    return __dest;
}

/* Append no more than N characters from SRC onto DEST.  */
char *strncat __P ((char *__restrict __dest,
					__const char *__restrict __src, size_t __n))
{
    unsigned int i = 0;
    char *d = ((char *) __dest), *s = ((char *) __src);

    while ( *d != '\0' )
		d++;

    do
    {
		*d++ = *s++;
		i++;
    } while ( (i < __n) && (*s != '\0') );

    return __dest;
}

/* Compare N characters of S1 and S2.  */
int strncmp __P ((__const char *__s1, __const char *__s2, size_t __n))
{
    unsigned int i = 1;

    while ( (i < __n) && (*__s1 != '\0') && (*__s2 == *__s1) )
    {
		i++; __s1++; __s2++;
    }

    return ((int) *__s2) - ((int) *__s1);
}

#endif /* OCT_SW_MODEM */


#if 0 // No one (in the kernel) should call malloc and free like a user does:
/* Allocate SIZE bytes of memory.  */
__malloc_ptr_t malloc __MALLOC_P ((size_t __size))
{
    return kmalloc( __size, GFP_KERNEL );
}

/* Free a block allocated by `malloc', `realloc' or `calloc'.  */
void free __MALLOC_P ((__malloc_ptr_t __ptr))
{
	kfree(__ptr);
}
#endif


/* Just for the v34batch in shell mode (not kernel): */
#if ( (UK_MODE == UK_KERNEL) && defined(BATCH_INCLUDE) )

#include <stdio.h>

FILE *stdin;

inline int _IO_getc( FILE *__file )
{
    return EOF;
}

/* Open a file and create a new stream for it.  */
inline FILE *fopen __P ((__const char *__restrict __filename,
						 __const char *__restrict __modes))
{
    return ((FILE *) 0);
}

/* Close STREAM.  */
inline int fclose __P ((FILE *__stream))
{
    return 0;
}

/* Read chunks of generic data from STREAM.  */
inline size_t fread __P ((void *__restrict __ptr, size_t __size,
						  size_t __n, FILE *__restrict __stream))
{
    *((char *) __ptr) = '\0';
    return 0;
}

/* Write chunks of generic data to STREAM.  */
inline size_t fwrite __P ((__const void *__restrict __ptr, size_t __size,
						   size_t __n, FILE *__restrict __s))
{
    return __size * __n;
}

#endif /* ( (UK_MODE == UK_KERNEL) && defined(BATCH_INCLUDE) ) */
