/*
 * missing_c.c - c-implementation of some missing functions under linux.
 */

#include <linux/malloc.h>
#include "missing_c.h"


void *kernelmalloc( unsigned int Size )
{
	return kmalloc( Size, GFP_KERNEL );
}

void kernelfree( void *pData )
{
	kfree( pData );
}

void __pure_virtual ( void )
{

#if ( UK_MODE == UK_KERNEL )
    printk( "pure virtual method called\n" );
#else
    fprintf( stderr, "pure virtual method called\n" );
#endif

}


/* The following are taken from octopus/osspecific/ostime.c, and are here only
   for when not using octopus... */
#if ( OCT_SW_MODEM == 0 )

static char FSaveMem[200];

static int save_cr0( void )
{
	int cr0;
	
	asm( "movl %%cr0, %%eax" : "=a" (cr0) : : "cc", "memory" );
 
	return cr0;

}  /* save_cr0 */


static void restore_cr0( int cr0 )
{

	asm( "movl  %%eax, %%cr0" : "=a" (cr0) );

}  /* restore_cr0 */


int OSFloatPrefix( void )
{
	unsigned long flags;
	int cr0;

	save_flags(flags);

	cli();
	cr0 = save_cr0();
	ClearTS();

	asm( "fsave (%0) \n\t"
		 "fwait \n"
		 : : "r" (FSaveMem) : "cc", "memory" );

	restore_flags(flags);

	return( cr0 );

}  /* OSFloatPrefix */


BOOL OSFloatSuffix( int Id )
{
	unsigned long flags;

	save_flags(flags);

	cli();
	ClearTS();

	asm( "frstor (%0) \n\t"
		 "fwait \n"
		 : : "r" (FSaveMem) );

	restore_cr0( Id );
    restore_flags( flags );

	return( TRUE );

}  /* OSFloatSuffix */


BOOL IsTSOn( void )
{
    BOOL ret;

    asm( "movl %%cr0, %0 \n\t"
		 "shrl $3, %0 \n\t"
		 "andl $1, %0 \n\t"
		 : "=a" (ret) : : "cc", "memory" );

    return ret;

}  /* IsTSOn */


void ClearTS( void )
{

   asm( "movl   %%cr0, %%eax \n\t"
		"andl   $0xfffffff7, %%eax \n\t"
		"movl   %%eax, %%cr0 \n" );

}  /* ClearTS */


#endif /* OCT_SW_MODEM == 0 */
