/*
 * testdev.c
 */


#include <stdio.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "vmod_ioctl.h"

char buf[1000];

int main( int argc, char **argv )
{
    int ret;
    FILE *fp;
    int fd;
    char buf[128];
    int modem_ver, glob_ver;

    if ( (fp = fopen(argv[1], "r+")) == NULL ) {
	fprintf( stderr, "%s: could not open device %s", argv[0], argv[1] );
	perror( " " );
	return errno;
    }
    fd = fileno(fp);

    printf( "fread returned %d\n", (ret = fread(buf, 1, 1000, fp)) );
    if ( ret != 1000 )
	perror( "fread" );

    getchar();

    ret = ioctl(fd, VMOD_IOC_GETMODVER, &modem_ver);
    printf( "ioctl(%x) returned %d, modem_ver = %d\n",
	    VMOD_IOC_GETMODVER, ret, modem_ver );
    if ( ret )
	perror( "ioctl GETMODVER" );

    ret = ioctl(fd, VMOD_IOC_GETGLBVER, &glob_ver);
    printf( "ioctl(%x) returned %d, glob_ver = %d\n",
	    VMOD_IOC_GETGLBVER, ret, glob_ver );
    if ( ret )
	perror( "ioctl GETGLBVER" );

    ret = ioctl(fd, VMOD_IOC_SETMODE, 0/*CALLER*/);
    printf( "ioctl(%x) returned %d\n", VMOD_IOC_SETMODE, ret );
    if ( ret )
	perror( "ioctl SETMODE" );

    getchar();

#if 0
    printf( "fwrite returned %d\n", (ret = fwrite(buf, 1, 1000, fp)) );
#else
    printf( "write returned %d\n", (ret = write(fd, buf, 1000)) );
#endif
    if ( ret != 1000 )
	perror( "fwrite" );

    fclose( fp );

    return 0;

}
