/*
 * v34modmule.c - main functions of v34 module (for linux kernel).
 */

#define EXPORT_SYMTAB
#include "ossysenv.h"
#include <linux/module.h>

#include "ktime.h"
#include "v34module.h"
//#include "v34device.h"
#include "v34wrapper.h"

EXPORT_SYMBOL_NOVERS( GetV34Interface );

int debug_mode = 0;
//int run_as_device = 0;
MODULE_PARM( debug_mode, "i" );
//MODULE_PARM( run_as_device, "i" );

long int aptm[2] = { 1234567890, 1234567890 };

#if ( RUN_AS_BATCH == 1 )
extern int main( int argc, char *argv[] );
#endif

int init_module(void)
{
#if 0
    struct timeval tmv;
    struct tm stm;

    get_fast_time( &tmv );
    ktime_tv_sec_to_tm( &stm, tmv.tv_sec );
    printk( "-=-=-=-=- V34 up at: %02d/%02d/%d, %02d:%02d:%02d -=-=-=-=-\n",
			stm.tm_mday, stm.tm_mon+1, 1900+stm.tm_year,
			stm.tm_hour, stm.tm_min, stm.tm_sec );
    printk( MOD_NAME ": init_module!!\n");
#endif

#if ( RUN_AS_BATCH == 1 )
    printk( "After batch run, main returned %d\n", main(0, 0) );
#else
#if 0
    if ( run_as_device )
    {
		if ( FALSE == Vmod_InitGlobals() )
		{
/*  			printk( "InitGlobals failed.\n" ); */
			return -1;
		}

		if ( FALSE == device_init() )
		{
/*  			printk( "device_init failed!\n" ); */
			Vmod_CloseGlobals();
			return -2;
		}
    }
#endif
#if 0
    else {
		printk( MOD_NAME ": GetV34Interface @0x%lx\n",
				(unsigned long) GetV34Interface );

		printk( MOD_NAME ": V34ExportedFunctions @0x%lx:\n",
				(unsigned long) &V34ExportedFunctions );
		printk( "  GetModemInstance @0x%lx,\n",
				(unsigned long) V34ExportedFunctions.GetModemInstance );
		printk( "  CloseModemInstance @0x%lx,\n",
				(unsigned long) V34ExportedFunctions.CloseModemInstance );
		printk( "  GetCModemVersion @0x%lx,\n",
				(unsigned long) V34ExportedFunctions.GetCModemVersion );
		printk( "  GetCAppGlobengVersion @0x%lx,\n",
				(unsigned long) V34ExportedFunctions.GetCAppGlobengVersion );
		printk( "  SetMemoryAllocator @0x%lx,\n",
				(unsigned long) V34ExportedFunctions.SetMemoryAllocator );
    }
#endif

#endif

/*      printk( "-=-=-=-=- " MOD_NAME " compiled on %s %s -=-=-=-=-\n", */
/*  			__DATE__, __TIME__ ); */
/*      printk( MOD_NAME ": loaded.\n" ); */

    return 0;
}


void cleanup_module(void)
{
/*      printk( MOD_NAME ": cleanup_module!!\n"); */

#if ( RUN_AS_BATCH == 1 )
    printk( "After batch run, closing...\n" );
#else
#if 0
    if ( run_as_device )
    {
		device_close();
		Vmod_CloseGlobals();
    }
#endif
#endif

/*      printk( MOD_NAME ": unloaded.\n" ); */
}


void *GetV34Interface( void )
{
    return (void *) &V34ExportedFunctions;

}  /* GetV34Interface */
