/*
 * v34wrapper.h - header file for v34wrapper - V34 cmodem-interface.
 *
 * NOTE: This file is included by v34wrapper.cpp (as a __cplusplus file), and
 *	 by v34module.c (as a c file). Thus, C++ things (for v34wrapper.cpp)
 *	 should be inside the `#ifdef __cplusplus' statement.
 */

#ifndef _V34WRAPPER_H_
#define _V34WRAPPER_H_


#include "sysenv.h"
#include "hsf_types.h"
#include "modem.h"    /* modem.h is c-safe! */

#ifdef __cplusplus
extern "C" {
#endif

    extern DP_EXPORT_FUNCTIONS_T V34ExportedFunctions;

    BOOL Vmod_InitGlobals( void );
    BOOL Vmod_CloseGlobals( void );
    DWORD V34_GetCModemVersion( void );
    DWORD V34_GetCAppGlobengVersion( void );
    BOOL V34_GetModem( HANDLE *modem, int modem_num );
    BOOL V34_ModMonitor( HANDLE modem,
			 DWORD dwMonitorCode, PVOID pInBuffer,
			 DWORD nInBufferSize, PVOID pOutBuffer,
			 DWORD nOutBufferSize, PDWORD pBytesReturned );
    BOOL V34_ModConfig( HANDLE modem,
			DWORD dwConfigCode, PVOID pInBuffer,
			DWORD nInBufferSize, PVOID pOutBuffer,
			DWORD nOutBufferSize, PDWORD pBytesReturned );
    BOOL V34_SetCallMode( HANDLE modem, DP_MODE_t mode );
    BOOL V34_InitModem( HANDLE modem );
    BOOL V34_Apply( HANDLE modem,
		    short* InBuffer, int LenInBuf,
		    short* OutBuffer, int LenOutBuf );
    BOOL V34_CloseModem( HANDLE *modem, int modem_num );


#ifdef __cplusplus
}
#endif


#endif
